<?php
$input=REST::input();
REST::load('inc/groups/groups.php');
$GID=strtoupper($input->getParts(2));
REST::check()->assure(groups::groupExists($GID),new NotFoundException('The group with GID '.$GID.' does not exist'));
REST::check()->assure(session::userExists($input->getParts(3)),new NotFoundException('The user with GUID '.$input->getParts(3).' does not exist'));
switch(REST::getMethod()) {
	case REST::get:
		$q=$remote_connection->query('SELECT * FROM `groups` WHERE UPPER(`gid`)=\''.$GID.'\' AND `user`=\''.$input->getParts(3).'\'');
		if(!$q) REST::output()->setData(array('status'=>false));
		elseif($q->num_rows==1) REST::output()->setData(array('member'=>true));
		else REST::output()->setData(array('member'=>false));
		break;
	case REST::post:
		auth::granted(auth::write_db_groups,true);
		REST::check()->parameter_exists('administrator');
		$data=$input->getData();
		REST::check()->assure($data['administrator']==1||$data['administrator']==0,new BadRequestException('The value of the parameter administrator should either be 0 or 1'));
		REST::check()->assure(groups::isGroupAdmin($GID),new ForbiddenException('You are not an administrator of the group with GID '.$GID));
		$c0=$remote_connection->query('SELECT * FROM `groups` WHERE UPPER(`gid`)=\''.$GID.'\' AND `user`=\''.REST::input()->getParts(3).'\'');
		if(!$c0) {
			REST::output()->setData(array('status'=>false));
			return;
		}
		REST::check()->assure($c0->num_rows==1,new NotFoundException('The user with GUID '.$input->getParts(3).' is not a member of group with GID '.$GID));
		$q=$remote_connection->query('UPDATE `groups` SET `admin`='.$data['administrator'].' WHERE `user`=\''.$input->getParts(3).'\' AND UPPER(`gid`)=\''.$GID.'\'');
		if(!$q) REST::output()->setData(array('status'=>false));
		else REST::output()->setData(array('status'=>true));
		break;
	default:
		return false;
}

