<?php
REST::load('inc/groups/groups.php');
switch(REST::getMethod()) {
	case REST::get: //List my groups
		$grps=groups::getMyGroups();
		foreach($grps as $grp) {
			$grpnam=groups::getName($grp);
			REST::output()->appendData(array('gid'=>$grp,'name'=>$grpnam));
		}
		break;
	case REST::put: //Create new group
		auth::granted(auth::write_db_groups,true);
		$data=REST::input()->getData();
		REST::check()->parameter_exists('name');
		REST::check()->preg_match('/^[a-zA-Z0-9_]+$/', $data['name'],'name');
		REST::check()->assure(!groups::groupExists($data['name']),new ConflictException('This groupname is already in use'));
		$q=array();
		REST::load('inc/utils/guid.php');
		$uuid=guid();
		$q[]=$remote_connection->query('INSERT INTO `groups_names` VALUES(\''.$uuid.'\', \''.$data['name'].'\')');
		$q[]=$remote_connection->query('INSERT INTO `groups` VALUES(\''.$uuid.'\',\''.session::$guid.'\',1)');
		if(!array_search(false, $q,true)) {
			REST::output()->setData(array('status'=>true));
			REST::success(201);
		}
		else REST::output()->setData(array('status'=>false));
		break;
	default:
		return false;
}
