<?php
$input=REST::input();
switch (REST::getMethod()) {
	case REST::get: //Show user info
		$q=$local_connection->query('SELECT `GUID`,`username` FROM `users` WHERE `GUID`=\''.$local_connection->escape_string($input->getPart()).'\'');
		if($q->num_rows!=1) throw new NotFoundException('This user does not exist');
		$data=$q->fetch_assoc();
		REST::output()->setData($data);
	break;
	case REST::delete: //Delete this user
		auth::init();
		auth::granted(auth::all,true);
		REST::check()->assure(session::isAdmin(),new UnauthorizedException('You need admin privileges to delete a user'));
		$q=$local_connection->query('DELETE FROM `users` WHERE `GUID`=\''.$local_connection->escape_string($input->getPart().'\''));
		if($q) REST::output()->setData(array('status'=>true));
		else REST::output()->setData(array('status'=>false));
	default:
		return false;
}