<?php
switch (REST::getMethod()) {
	case REST::get: //Show user info
		auth::init();
		$mail=auth::granted(auth::read_mail_addr);
		$lang=auth::granted(auth::read_lang);
		$q=$local_connection->query('SELECT `GUID`,`username`'.($mail?',`email`':'').($lang?',`lang`':'').' FROM `users` WHERE `GUID`=\''.$local_connection->escape_string(session::$guid).'\'');
		if($q->num_rows!=1) throw new GoneException('Authenticated user no longer exists');
		$data=$q->fetch_assoc();
		if(isset($data['lang'])) $data['lang']=unserialize($data['lang']);
		REST::output()->setData($data);
	break;
	case REST::post: //Update user info
		auth::init();
		auth::granted(auth::write_lang,true);
		$data=REST::input()->getData();
		REST::check()->parameter_exists('lang');
		$data['lang']=(REST::getDataType()==REST::json?json_decode($data['lang']):unserialize($data['lang']));
		if(!is_array($data['lang'])) throw new BadRequestException('Please provide a valid lang parameter');
		$q=$local_connection->query('UPDATE `users` SET `lang`=\''.serialize($data['lang']).'\' WHERE `GUID`=\''.$local_connection->escape_string(session::$guid).'\'');
		if($q) {
			REST::output()->setData(array('status'=>true));
		}
		else {
			REST::output()->setData(array('status'=>false));
		}
	break;
	default:
		return false;
}