<?php
$input=REST::input();
switch (REST::getMethod()) {
	case REST::get: //List
		$q=$local_connection->query('SELECT `GUID`,`username` FROM `users`');
		while($r=$q->fetch_assoc()) {
			REST::output()->appendData($r);
		}
		break;
	case REST::put: //Create new
		auth::init();
		auth::granted(auth::all,true);
		REST::check()->assure(session::isAdmin(),new UnauthorizedException('You need admin privileges to create a user'));
		$data=$input->getData();
		REST::check()->parameter_exists('username');
		REST::check()->parameter_exists('password');
		REST::check()->parameter_exists('email');
		if(session::register($data['username'], $data['password'], $data['email'])) {
			REST::output()->setData(array('status'=>true,'errors'=>array()));
			REST::success(201);
		}
		else {
			$errors=JSError::get();
			REST::output()->setData(array('status'=>false,'errors'=>$errors));
		}
		break;
	default:
		return false;
}