<?php //@./inc/API_keys/keycheck.php ?>
<?php
/**
 * RemoteCP API key checker class
 * @package remote
 * @subpackage api
 */
class api_key_check {
	/**
	 * Holds the database connection
	 * @var mysqli
	 */
	private $connection;
	private $table;
	/**
	 * Constructor
	 * @param MySQLi $connection
	 * @param string $table
	 */
	function api_key_check($connection,$table) {
		$this->connection=$connection;
		$this->table=$table;
	}
	/**
	 * Checks the API key
	 * @param string $apikey
	 * @param string $ip
	 * @return bool
	 */
	function checkkey($apikey,$ip) {
		return ($this->connection->query("SELECT * FROM `$this->table` WHERE `key`='".$this->connection->escape_string($apikey)."' AND `ip`= inet_aton('".$this->connection->escape_string($ip)."')")->num_rows==1);
	}
}