#!/usr/bin/php
<?php
chdir(__DIR__);
$lines=file('licenses.txt',FILE_IGNORE_NEW_LINES|FILE_SKIP_EMPTY_LINES);
$TABLE=array('headers'=>array(),'content'=>array());
$HEADER='';
foreach($lines as $line) {
	$line=trim($line);
	$startchar=substr($line, 0,1);
	if($startchar=='!') { //File header
		$HEADER.=substr($line,1).'<br>';
		continue;
	} 
	if($startchar=='|') { //table header
		$line=substr($line, 1,-1);
		$headers=explode("\t", $line);
		if(empty($TABLE['headers'])) { //First set of headers
			$TABLE['headers']=$headers;
			continue;
		}
		else {
			continue;
		}
	}
	list($files,$lic,$auth,$site)=explode("\t",$line);
	$lics=explode(',', $lic);
	foreach($lics as &$lc) {
		$lc=trim($lc);
		$lc='<a href="'.str_replace(' ', '_', $lc).'.txt">'.$lc.'</a>';
	}
	$lic=implode(', ', $lics);
	$files=explode(',', $files);
	foreach($files as $file) {
		$file=trim($file);
		$TABLE['content'][$file]=array($file,$lic,$auth,$site);
	}

}
ksort($TABLE['content']);
$wrt=fopen('licenses.html', 'w');
fwrite($wrt,$HEADER);
fwrite($wrt, '<table><thead><tr>');
foreach($TABLE['headers'] as $header) {
	fwrite($wrt,'<th>'.$header.'</th>');
}
fwrite($wrt,'</tr></thead><tbody>');
foreach($TABLE['content'] as $row) {
	fwrite($wrt, '<tr>');
	foreach($row as $cell) {
		if(substr($cell,0,7)=='http://') $cell='<a href="'.$cell.'">'.$cell.'</a>';
		fwrite($wrt, '<td>'.$cell.'</td>');
	}
	fwrite($wrt, '</tr>');
}
fwrite($wrt, '</tbody></table>');
