<?php
define('NO_UURL',true);
define('__DEBUG__',true);
$identity='';
$attributes=array();
chdir(__DIR__.'/..'); // Our root is at the parent directory!
require 'inc/controllers.php';
if($_SESSION['auth_type']!='openid') {
	JSError::add('You need an OpenID to link to your account.');
}
if(session::isBoundOpenId(sha1($_SESSION['openid']['identity']))) {
	JSError::add('This OpenID is already bound.');
}
if(JSError::count()>0) {
	echo JSError::show();
	exit;
}
if(!isset($_POST['user'])) {
	echo '<form method="POST" onsubmit="simplerequest.post(\'/openid/create_account.php?\',$(this).serialize(),\'Account registered and bound with OpenID\',\'Error registering account\',refreshFrames);return false;">';
	echo '<label>'.$t->_('Username').':<input type="text" name="user" maxlength="30"></label><br>';
	if(!isset($_SESSION['openid']['attributes']['contact/email'])) {
		$email='';
	}
	else {
		$email=$_SESSION['openid']['attributes']['contact/email'];
	}
	echo '<label>'.$t->_('E-mail address').':<input type="text" name="email" maxlength="50" value="'.$email.'"></label><br>';
	echo '<input type="submit" value="'.$t->_('Register').'" class="button">';
	echo '</form>';
}
else {
	if(!session::register($_POST['user'], NULL, $_POST['email'])) {
		echo JSError::show();
	}
	else {
		$guid=session::getGUID($_POST['user']);
		if(session::bindOpenID($guid, $_SESSION['openid']['identity'])) {
			echo 'true';
		}
		else {
			JSError::add('User registered but error while binding OpenID');
			echo JSError::show();
		}
	}
	
}