<?php //@./remote_panel.php ?>
<?php
define('__DEBUG__',true);
/**
 * remote_panel.php - Main script
 * This file is called from the webbrowser when using RemoteCP to connect to a remote database.
 */ 
require('inc/controllers.php');
require_once('inc/rdb/rdb.php');
require_once('inc/groups/groups.php');
require_once('inc/accountlevels.php');
$t->addFile(__FILE__);
//Basic HTML start
?>
<!DOCTYPE html>
<html><head>
<?php
$titleq=$local_connection->query('SELECT `title` FROM `remote_databases` WHERE `key`=\''.rdb_auth::$dbid.'\'');
if($titleq->num_rows==0) {
	$title='';
}
else {
	$title=$titleq->fetch_object()->title;
}
?>
<title>RemoteCP - <?php echo $title; ?></title>
<link type="text/css" href="<?php echo URL_JQUERY; ?>/css/jquery-ui.css" rel="stylesheet">
<link type="text/css" href="<?php echo DOMAIN; ?>/style.css" rel="stylesheet">
<script type='application/javascript' src='<?php echo DOMAIN; ?>/scripts.js'></script>
<script type='application/javascript' src='<?php echo DOMAIN; ?>/scripts/live.js'></script>
<script type="application/javascript" type="application/javascript">
var URL_SCRIPTS="<?php echo URL_SCRIPTS; ?>"; //PHP Constant URL_SCRIPTS
var UURL="<?php echo $_SESSION['uurl']; ?>"; //Your unique URL
</script>
<script>
	function openusers(element) {
		element.id='uid_'+Math.random();
		selectuser=open('?control=getsysusers&uurl='+UURL+'&id='+element.id,'userselect','resizable=no,width=200,height=400'); selectuser.opener=self;
	}
	function opengroups(element) {
		element.id='uid_'+Math.random();
		selectgrp=open('?control=getrgroups&uurl='+UURL+'&id='+element.id,'groupselect','resizable=no,width=200,height=400'); selectgrp.opener=self;
	}
</script>
<?php


if(!isset($_GET['control'])) { ?>
<script type="application/javascript">
window.onerror=function(msg, url, line) {$('#dlg_js-e').dialog('open'); $('#dlg_js-e').append('<div class="ui-state-highlight ui-corner-all" style="margin-top: 20px; padding: 0 .7em;"><p><span class="ui-icon ui-icon-info" style="float: left; margin-right: .3em;"></span>Fout beschrijving: <tt>!JS['+url+':'+line+'::'+msg+']!</tt></p></div>')}
var loaded_scripts=new Array();
loaded_scripts.push('NULL');
</script>

<script type="application/javascript">
$(function() {
		$('#dlg_log-in').dialog({
			buttons: {
				"<? echo $t->_('Log in'); ?>": function() {
					logged_in=sjax.post('panel.php?control=login&uurl='+UURL,'user='+document.login.user.value+'&pass='+document.login.pass.value);
					if(logged_in=="true") {
						refreshFrames();
						$(this).dialog('close');
					}
					else if(logged_in=="false") {
						$(this).prepend('<div id="dlg_log-in-error" class="ui-state-error ui-corner-all" style="padding: 0 .7em;"><p><span class="ui-icon ui-icon-alert" style="float: left; margin-right: .3em;"></span><?php echo $t->_('Login failed. Try again'); ?></p></div>');
						setTimeout('$("#dlg_log-in-error").hide("clip","slow")',2000);
					}
					else {
						$(this).prepend(logged_in);
					}
				}
			},
			close: function() {
				document.login.reset();
			}
		}
		);
		<?php if(!session::$logged_in) { echo "$('#dlg_log-in').dialog('open');" ;}?>

	//Hide single login
	if(window!=top) {
		$('#single_login').hide();
		$('.gui-dlg').dialog('destroy');
	}
	openLoc('<?php echo $t->_('Desktop') ;?>','?control=desktop','desktop');
	$('#tabs ul li:first span').hide();
});


</script>

</head>
<body class='panel'>
<div id='single_login'>
<ul id='messages'></ul>
	<div id='login-container'>
		<span id="buttons-main"></span>
		<div id='versions'>
		</div>
		<div>
		<?php echo sprintf($t->_('RemoteCP is running in compatiblity mode.<br>%1$s and %2$s have full support, maybe you should switch?'), 'Mozilla Firefox, MS Internet Explorer','Google Chrome'); ?>
		</div>
		<div id="dlg_log-in" title="<?php echo $t->_('Log in'); ?>"
			class="gui-dlg gui-dlg-fs gui-dlg-noresize">
			<form name="login">
			<?php echo $t->_('Username'); ?>
				: <input type="text" name="user" id="login-user"><br>
				<?php echo $t->_('Password'); ?>
				: <input type="password" name="pass" id="login-pass">
			</form>
		</div>
		<div id="dlg_register" title="<?php echo $t->_('Register'); ?>"
			class="gui-dlg gui-dlg-fs gui-dlg-noresize"></div>
	</div>
</div>
<!-- <  id=single_login -->
<div id="tabs">
	<ul>
	</ul>
</div>
<div id="dlg_js-e" title="JavaScript ERROR" class="gui-dlg gui-dlg-fs gui-dlg-alert">
<div class="ui-state-error ui-corner-all" style="padding: 0 .7em;"><p><span class="ui-icon ui-icon-alert" style="float: left; margin-right: .3em;"></span><?php echo $t->_('An error occured in your browser\'s JavaScript interpreter.</p><p>Probably the page doesn\'t work anymore.'); ?></p></div>
</div>
</body>
</html>
<?php } 
else {
	if(!session::$logged_in) { //Not logged in 
		header('HTTP/1.1 401 Unauthorized');
		?>
<!-- AJAX_START --><!-- HEADERS >
<AJAX_SCRIPTLOC>NULL</AJAX_SCRIPTLOC>
<AJAX_SCRIPTEVAL>NULL</AJAX_SCRIPTEVAL>
< HEADERS -->
<div class="ui-state-highlight ui-corner-all" style="padding: 0 .7em;"><p><span class="ui-icon ui-icon-info" style="float: left; margin-right: .3em;"></span>
<?php echo $t->_('<strong>Authentication expired</strong> You were too long inactive. Your session has expired.'); ?></p><p><span aria-disabled="false" role="button" class="ui-button ui-widget ui-state-default ui-corner-all ui-button-text-only" onclick="parent.$('#dlg_log-in').dialog('open');"><span class="ui-button-text"><?php echo $t->_('Relogin'); ?></span></span>
</p></div>
<!-- AJAX_STOP --><?php
	exit;
	}
	elseif(!rdb_auth::$logged_in) { //Not authenticated to access the database
		header('HTTP/1.1 419 Database access denied');
?>
<!-- AJAX_START --><!-- HEADERS >
<AJAX_SCRIPTLOC>NULL</AJAX_SCRIPTLOC>
<AJAX_SCRIPTEVAL>NULL</AJAX_SCRIPTEVAL>
< HEADERS -->
<div class="ui-state-highlight ui-corner-all" style="padding: 0 .7em;"><p><span class="ui-icon ui-icon-info" style="float: left; margin-right: .3em;"></span>
<?php echo $t->_('<strong>Access denied</strong> You are not allowed to access this database.'); ?></p>
</p></div>
<!-- AJAX_STOP --><?php
	exit;
	}
?>
</head><body>
<!-- AJAX_START -->
<?php
	if($_GET['control']=="desktop") { 
		//Load system_remote/desktop.php
		require_once('system_remote/desktop.php');
	}
	else if($_GET['control']=="addons") {
		require_once('system_remote/plugins/init.php'); //Load APIs
		if(!isset($_GET['aref'])) $_GET['aref']='';
		//Load system_remote/plugins/?????.php
		if(!require_once('system_remote/plugins/'.$_GET['aref'].'/default.php')) { exit; }
	}
	else if($_GET['control']=="admin"||$_GET['control']=='database') {
		require_once('system_remote/database.php');
	}
	else if($_GET['control']=="create_site") {
		//Load site creation module
		require_once('system_remote/create_site.php');
	}
	else if($_GET['control']=="getsysusers") {
		//Load system_local/get_sys_users.php
		require_once('system_local/get_sys_users.php');
	}
	else if($_GET['control']=='getrgroups') {
		//Load system_remote/get_remote_groups.php
		require_once('system_remote/get_remote_groups.php');
	}
	else if($_GET['control']=='groups') {
		//Load remote group administration
		require_once('system_remote/groups.php');
	}
}?>
<!-- AJAX_STOP --></body></html>
