<?php //@./scripts/db_scripts.js.php ?>
var db= {
	create: {
		send: function(elem) {
			_post='';
			_post+='name='+elem.name.value;
			conn_type=0;
			if(elem.conn_type[1].checked) {
				conn_type=1;
			}
			_post+='&conn_type='+conn_type;
			if(conn_type==0) {
				_post+='&conn_host='+elem.conn_0_host.value;
				_post+='&conn_user='+elem.conn_0_user.value;
				_post+='&conn_pass='+elem.conn_0_pass.value;
				_post+='&conn_db='+elem.conn_0_db.value;
			}
			else {
				_post+='&conn_host='+elem.conn_1_host.value;
				_post+='&conn_user='+elem.conn_1_user.value;
				_post+='&conn_pass='+elem.conn_1_pass.value;
				_post+='&conn_db='+elem.conn_1_db.value;
			}
			_post+='&api_ip='+elem.api_ip.value;
			_post+='&register_db=1';
			simplerequest.post('?control=database',_post,'<?php echo $t->_('New database registered'); ?>','<?php echo $t->_('Error registering database'); ?>',refreshLoc);
		},
		question: function(formname) {
			win=window.open('?control=database&function=help&name='+formname,'database_help','resizable=no,width=800,height=200');
			win.focus();
		},
		check_ip: function(elem) {
			what=elem.value;
			valid=true;
			if (what.search(/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/) != -1) {
				var myArray = what.split(/\./);
				if (myArray[0] > 255 || myArray[1] > 255 || myArray[2] > 255 || myArray[3] > 255) valid=false;
				if (myArray[0] == 0 && myArray[1] == 0 && myArray[2] == 0 && myArray[3] == 0) valid=false;
			}
			else {
				valid=false;
			}
			if(!valid){
				elem.parentNode.style.color='red';
			}
			else {
				elem.parentNode.style.color='green';
			}
		}
	},
	admin: {
		settings: {
			send: function(elem) {
				_post='';
				conn_type=0;
				if(elem.conn_type[1].checked) {
					conn_type=1;
				}
				_post+='conn_type='+conn_type;
				if(conn_type==0) {
					_post+='&conn_host='+elem.conn_0_host.value;
					_post+='&conn_user='+elem.conn_0_user.value;
					_post+='&conn_pass='+elem.conn_0_pass.value;
					_post+='&conn_db='+elem.conn_0_db.value;
				}
				else {
					_post+='&conn_host='+elem.conn_1_host.value;
					_post+='&conn_user='+elem.conn_1_user.value;
					_post+='&conn_pass='+elem.conn_1_pass.value;
					_post+='&conn_db='+elem.conn_1_db.value;
				}
				_post+='&db_title='+elem.db_title.value;
				_post+='&update_db=1';
				simplerequest.post('?control=admin&function=update_settings',_post,'<?php echo $t->_('Settings changed'); ?>','<?php echo $t->_('Error changing settings'); ?>',refreshCurrentTab);
			}
		},
		user: {
			editlvl: {
				func: function(user,cont){
					if(cont.value!=cont.getAttribute('orig_val')) {
						simplerequest.get('?control=admin&function=editlvl&user='+user+'&lvl='+cont.value,'<?php echo $t->_('Userlevel saved'); ?>','<?php echo $t->_('Error saving userlevel'); ?>',refreshCurrentTab);
					}
					else {
						db.admin.user.editlvl.collapse(cont);
					}
				},
				collapse: function(cont) {
					cont.parentNode.innerHTML=cont.value;
				},
				expand: function(user,cont) {
					selectbox=cont;
					newhtml='<select orig_val=\''+selectbox.innerHTML+'\' onblur=db.admin.user.editlvl.func(\''+user+'\',this)>';
					newhtml+='<option value="1"><?php echo $t->_('Site editor'); ?></option>';
					newhtml+='<option value="2"><?php echo $t->_('Site creator'); ?></option>';
					newhtml+='<option value="9"><?php echo $t->_('Database admin'); ?></option>';
					newhtml+='</select>';
					selectbox.innerHTML=newhtml;
					selectbox.getElementsByTagName('select')[0].focus();
				}
			},
			add: function(cont) {
				user=cont.parentNode.parentNode.getElementsByTagName('input')[0].value;
				simplerequest.post('?control=admin&function=adduser','username='+user,'<?php echo $t->_('User added'); ?>','<?php echo $t->_('Error adding user'); ?>',refreshCurrentTab);
			},
			delete: function(user) {
				simplerequest.post('?control=admin&function=deleteuser','username='+user,'<?php echo $t->_('User removed'); ?>','<?php echo $t->_('Error removing user'); ?>',refreshCurrentTab);
			}
		},
		delete: function() {
			simplerequest.get('?control=admin&function=delete','<?php echo $t->_('Database removed'); ?>','<?php echo $t->_('Error removing database'); ?>',self.close);
		}
	}
}