var sjax={
	obj:function(){
		if (window.XMLHttpRequest)
			{// code for IE7+, Firefox, Chrome, Opera, Safari
			xmlhttp=new XMLHttpRequest();
		}
		else
			{// code for IE6, IE5
			xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
		}
		return xmlhttp;
	},
	get:function(url) {
		var __TEMP__=new Array();
		$.ajax(url+'&uurl='+UURL,{async:false,success:function(data,textResp,jqXHR) {
			__TEMP__[0]=data;
			__TEMP__[1]=jqXHR;
		}});
		resp=this.strip(__TEMP__[0]);
		if(__TEMP__[1].status==200&&resp!='') {
			return resp;
		}
		else if(resp=='') {
			console.warn('Server returned empty page');
			console.info(__TEMP__[1]);
			return '<strong>Sorry,</strong> the server decided to say nothing.';
		}
		else {
			console.warn('WTF??? Nothing?');
			console.info(__TEMP__[1]);
			return '<strong>OOPS</strong> Something went wrong...';
		}
	},
	post:function(url,pp) {
		var __TEMP__=new Array();
		$.ajax(url+'&uurl='+UURL,{type: 'post', data: pp, async:false,success:function(data,textResp,jqXHR) {
			__TEMP__[0]=data;
			__TEMP__[1]=jqXHR;
		}});
		resp=this.strip(__TEMP__[0]);
		if(__TEMP__[1].status==200&&resp!='') {
			return resp;
		}
		else if(__TEMP__[1].status==500) {
			console.error('SJAX returned 500');
			console.info(__TEMP__[1].responseText);
			return 'false|PHP error';
		}
		else if(resp=='') {
			console.warn('Server returned empty page');
			console.info(__TEMP__[1]);
			return '<strong>Sorry,</strong> the server decided to say nothing.';
		}
		else {
			console.warn('WTF??? Nothing?');
			console.info(__TEMP__[1]);
			return '<strong>OOPS</strong> Something went wrong...';
		}
	},
	strip:function(html) {

		if(html.indexOf('<!-- AJAX_START -->')!=-1 && html.lastIndexOf('<!-- AJAX_STOP -->')!=-1) {
			ret= html.substring(html.indexOf('<!-- AJAX_START -->')+19,html.lastIndexOf('<!-- AJAX_STOP -->'));
		}
		else if(html.indexOf('<!-- AJAX_START -->')!=-1) {
			ret= html.substring(html.indexOf('<!-- AJAX_START -->')+19);
		}
		else if(html.lastIndexOf('<!-- AJAX_STOP -->')!=-1) {
			ret= html.substring(0,html.lastIndexOf('<!-- AJAX_STOP -->'));
		}
		else {
			ret= html;
		}
		if(ret.indexOf('<!-- HEADERS >')!=-1 && ret.indexOf('< HEADERS -->')!=-1) { //Handler for non-existing headers (after PHP errors)
			headers=ret.substring(ret.indexOf('<!-- HEADERS >')+14,ret.indexOf('< HEADERS -->'));
			script_url=headers.substring(headers.indexOf('<AJAX_SCRIPTLOC>')+16,headers.indexOf('</AJAX_SCRIPTLOC>'));
			if(!loaded_scripts.in_array(script_url)) { $.getScript(URL_SCRIPTS+'/'+script_url); loaded_scripts.push(script_url);} //Load script and put in loaded array
			evalc=headers.substring(headers.indexOf('<AJAX_SCRIPTEVAL>')+17,headers.indexOf('</AJAX_SCRIPTEVAL>'));
			if(evalc!="NULL") { eval(evalc); }
			ret=ret.substring(ret.indexOf('< HEADERS -->')+13);
		}
		ret=$.trim(ret);
		// From http://www.rgagnon.com/jsdetails/js-0041.html
		ret=ret.replace(/[\n\r]/g,'');
		// End from http://www.rgagnon.com/jsdetails/js-0041.html
		return ret;
	}		
};

var simplerequest= {
		get: function(url,successmsg,errmsg,execonsuccess){
			$.get(url+'&uurl='+UURL,function(data){
				data=sjax.strip(data);
				if(data=='true') {
					notice.message(successmsg,'');
					if(execonsuccess) {
						execonsuccess();
					}
				}
				else if(data=='false') {
					notice.alert(errmsg, '');
				}
				else if(data==''){
					notice.warning('No data','The server returned nothing!');
					console.warn('No data');
				}
				else {
					errors=data.split('|');
					if(errors[0]=='false') {
						errors[0]='';
						alrt=errors.join('<br>');
						notice.alert(errmsg, alrt);
					}
					else {
						notice.error('Unexpected condition','The server has gone mad');
						console.error('Unexpected condition');
						console.info(data);
					}
				}

			});
		},
		post: function(url,pp,successmsg,errmsg,execonsuccess) {
			$.post(url+'&uurl='+UURL,pp,function(data){
				data=sjax.strip(data);
				if(data=='true') {
					notice.message('', successmsg);
					console.log(successmsg);
					if(execonsuccess) {
						execonsuccess();
					}
				}
				else if(data=='false') {
					notice.alert('', errmsg);
					console.warn(errmsg);
				}
				else if(data==''){
					notice.warning('No data', 'The server returned nothing!');
					console.warn('No data');
				}
				else {
					errors=data.split('|');
					if(errors[0]=='false') {
						errors[0]='';
						alrt=errors.join('<br>');
						notice.alert(errmsg, alrt);
						console.warn(alrt);
					}
					else {
						notice.error('Unexpected condition','The server has gone mad');
						console.error('Unexpected condition');
						console.info(data);
					}
				}
				
			});
		}
};
/*$(document).ajaxError(function(ev,jqxhr,settings,ex){
	notice.error('Error loading page','Something went wrong. Check your connection');
	console.error(ev);
	console.info(jqxhr.response);
	console.log(settings);
	console.error(ex);
});*/
$.ajaxSetup({
	statusCode: {
		401: function() {
			notice.error('HTTP 401', 'You are no longer logged in. Please relogin');
			top.$('#dlg_log-in').dialog('open');
		},
		404: function() {
			notice.error('HTTP 404','Requested page not found. Check server configuration.');
		},
		403: function() {
			notice.error('HTTP 403','Forbidden. Probably server is being updated.');
		},
		418: function() {
			notice.error('HTTP 418','I\'m a teapot, and you don\'t have an UURL');
		},
		500: function() {
			notice.error('HTTP 500','Internal server error. Probably a PHP error occured, for details: see console');
		},
		503: function() {
			notice.error('HTTP 503','Service unavailable. The server is locked-down.');
		}
	},
	error: function (jqXHR, textStatus, errorThrown) {
		notice.error('AJAX error',errorThrown);
		console.warn(errorThrown);
		console.info(jqXHR);
		console.info(jqXHR.responseText);
		$('.gui-progress').hide();
	}
});


