<?php //@./system_local/database.php ?>
<!-- HEADERS >
<AJAX_SCRIPTLOC>db_scripts.js</AJAX_SCRIPTLOC>
<AJAX_SCRIPTEVAL>NULL</AJAX_SCRIPTEVAL>
< HEADERS --><?php
/**
 * database.php - Administrate a  database
 * This file is used to add a new database to RemoteCP
 */
function help($iname) {
	global $t;
	return "<a onclick='db.create.question(\"$iname\");'><img src='".URL_IMG."/Silk/help.png' alt='?' title='".$t->_('Help')."'></a>";
}
if(!isset($_GET['function']))
	$_GET['function']='create';

if($_GET['function']=='create') {
	if(!isset($_POST['conn_host'])) {
	echo "
	<form method='POST' onsubmit='db.create.send(this); return false'>
		<fieldset>
			<legend>".$t->_('Name')."</legend>
			<label>".$t->_('Database name').": <input name='name' type='text'></label>
		</fieldset>
		<fieldset>
			<legend>".$t->_('Connection')."</legend>
			<label><input name='conn_type' type='radio' value='0' onclick='$(this.parentNode.parentNode.getElementsByTagName(\"fieldset\")[0]).show(\"slow\");$(this.parentNode.parentNode.getElementsByTagName(\"fieldset\")[1]).hide(\"slow\")' checked>".$t->_('Normal')."</label> <label><input name='conn_type' type='radio' value='1' onclick='$(this.parentNode.parentNode.getElementsByTagName(\"fieldset\")[1]).show(\"slow\");$(this.parentNode.parentNode.getElementsByTagName(\"fieldset\")[0]).hide(\"slow\")'>".$t->_('HTTPMySQL')."</label> ".help('conn_type')."<br>
			<fieldset>
				<legend>".$t->_('MySQL')."</legend>
				<label>".$t->_('MySQL host').": <input name='conn_0_host' type='text'></label> ".help('conn_0_host')."<br>
				<label>".$t->_('MySQL username').": <input name='conn_0_user' type='text'></label><br>
				<label>".$t->_('MySQL password').": <input name='conn_0_pass' type='password'></label><br>
				<label>".$t->_('MySQL database').": <input name='conn_0_db' type='text'></label>
			</fieldset>
			<fieldset style='display: none'>
				<legend>".$t->_('HTTPMySQL')."</legend>
				<label>".$t->_('Domain').": <input name='conn_1_host' type='text'></label> ".help('conn_1_host')."<br>
				<label>".$t->_('Path to query.php').": <input name='conn_1_db' type='text'></label>/query.php ".help('conn_1_db')."<br>
				<label>".$t->_('Username').": <input name='conn_1_user' type='text'></label> ".help('conn_1_user')."<br>
				<label>".$t->_('Password').": <input name='conn_1_pass' type='password'></label> ".help('conn_1_pass')."<br>
			</fieldset>
		</fieldset>
		<fieldset>
			<legend>".$t->_('RemoteCP API')."</legend>
			<label>".$t->_('IP-address').": <input name='api_ip' type='text' onchange='db.create.check_ip(this)'></label> ".help('api_ip')."<br>
		</fieldset>
		<input type='submit' value='".$t->_('Add database')."'>
	</form>
	";
	}
	else {
		if($_POST['conn_type']==0) {
			$db_test=mysql_connect($_POST['conn_host'],$_POST['conn_user'],$_POST['conn_pass']);
			if(!mysql_select_db($_POST['conn_db'],$db_test)) JSError::add($t->_('MySQL connection error'));
		}
		else {
			include('inc/httpmysql/httpmysql.php');
			$db_test=new HTTPMySQL($_POST['conn_host'], $_POST['conn_user'], $_POST['conn_pass'], $_POST['conn_db'].'/query.php');
			if(!$db_test->ping())JSError::add($t->_('HTTPMySQL connection error'));
		}
		if(!filter_var($_POST['api_ip'], FILTER_VALIDATE_IP, FILTER_FLAG_NO_PRIV_RANGE | FILTER_FLAG_NO_RES_RANGE)) {
			JSError::add($t->_('Invalid IP-address'));
		}
		if(JSError::count()!=0) {
			echo JSError::show();
		}
		else {
			$key=md5($_POST['conn_host'].$_POST['conn_db'].$_POST['conn_user']);
			$api_key=md5(session::$guid.$key.$_POST['api_ip']);
			if(!$local_connection->query("INSERT INTO `remote_databases` VALUES ('$key','$_POST[conn_host]','$_POST[conn_type]','$_POST[conn_db]','$_POST[conn_user]','$_POST[conn_pass]','$_POST[name]','$api_key')")) {
				JSError::add($t->_('A database with these details already exists.'));
			}
			$local_connection->query("INSERT INTO `remote_databases_assignments` VALUES('$key','".session::$guid."',9)");
			$local_connection->query("INSERT INTO `api_keys` VALUES('$api_key',inet_aton('$_POST[api_ip]'),'".session::$guid."')");
			echo JSError::show();
		}
	}
}
else if($_GET['function']=="help") {
	$name=$_GET['name'];
	switch($_GET['name']) {
		case 'conn_type':
			echo "<h1>".$t->_('Connection')."</h1>";
			echo $t->_('<p>How should RemoteCP connect to your database?</p><p>Normal mode is preferred, but you have to be able to allow remote hosts to connect to your MySQL server. (Probably named \'Remote MySQL\' or \'Remote database access\' )</p><p>When it is not possible to choose sites who are allowed to connect to your database, you have to choose \'HTTPMySQL\'. However, this is a bit slower and requires more processing power on your server.</p>');
		break;
		case 'conn_0_host':
			echo "<script>var db ={ create: {question: function(formname) { window.open('?control=database&function=help&name='+formname,'database_help','resizable=no,width=800,height=200')}}}</script>";
			echo "<h1>".$t->_('MySQL host')."</h1>";
			echo sprintf($t->_('<p>The machine that runs the MySQL server</p><p>If this is \'localhost\' or \'127.0.0.1\' according to your documentation, you should enter your domainname %s here.'),help('conn_1_host'));
		break;
		case 'conn_1_host': 
			echo "<h1>".$t->_('Domain')."</h1>";
			echo $t->_('<p>Your domain is what you type to visit your website</p><p>It is placed behind http:// and before the first slash. (E.g.: <tt>http://<u>remotecp.co.cc</u>/1-Home/</tt>, <tt>remotecp.co.cc</tt> is the domain).</p>');
		break;
		case 'conn_1_db':
			echo "<script>var db ={ create: {question: function(formname) { window.open('?control=database&function=help&name='+formname,'database_help','resizable=no,width=800,height=200')}}}</script>";
			echo "<h1>".$t->_('Path to query.php')."</h1>";
			echo sprintf($t->_('<p>The path to the file query.php on your server.</p><p>The path is the part after the domain %s. For your convenience, whe have already appended \'/query.php\'. So, you must also omit that from the path.</p>'),help('conn_1_host'));
		break;
		case 'conn_1_user':
			echo "<h1>".$t->_('Username')."</h1>";
			echo $t->_('<p>What username is required to access \'query.php\'?</p><p>You should secure query.php with an username and password combination to avoid unallowed changes to your websites. What username did you use for that purpose?</p>');
		break;
		case 'conn_1_pass':
			echo "<h1>".$t->_('Password')."</h1>";
			echo $t->_('<p>What password is required to access \'query.php\'?</p><p>You should secure query.php with an username and password combination to avoid unallowed changes to your websites. What password did you use for that purpose?</p>');
		break;
		case 'api_ip':
			echo "<script>var db ={ create: {question: function(formname) { window.open('?control=database&function=help&name='+formname,'database_help','resizable=no,width=800,height=200')}}}</script>";
			echo "<h1>".$t->_('IP-address')."</h1>";
			echo sprintf($t->_('<p>What is the IP-address belonging to your server?</p><p>An IP address is a unique identifier of 4 times a number from 0 to 255, separated by a point. (E.g.:<tt><u>69.175.113.125</u></tt>)</p><p>To find the IP address of your server open a Command Prompt window (Folder Accessories) and type <tt>ping &lt;domain %s &gt; </tt>. The first rule is roughly <tt> Pinging remotecp.co.cc  [<u>199.27.134.101</u>] with 32 bytes of data: </tt>. The underlined part is the IP address of your server. </p>'),help('conn_1_host'));
	}

}