<?php //@./system_local/user_props.php ?>
<!-- HEADERS >
<AJAX_SCRIPTLOC>account_scripts.js</AJAX_SCRIPTLOC>
<AJAX_SCRIPTEVAL>setTimeout('$("#user_edit_language").sortable().removeClass("ui-state-disabled");',1)</AJAX_SCRIPTEVAL>
< HEADERS --><?php
   /**
    * user_props.php - Jquery UI control panel (?control=userinfo)||(?control=useredit)
    * REQUIRE in cpanel
    *
    * COPYRIGHT: Jpmaster77's login script
    * URL: http://evolt.org/PHP-Login-System-with-Admin-Features
    * CHANGED BY lnhost.co.cc
    * ALL CHANGES COPYRIGHT 2010 lnhost.co.cc
    */

if($_GET['control']=="userinfo") {
	$req_user = trim($_GET['user']);
	if(!$req_user || strlen($req_user) == 0 ||
	   !session::userExists($req_user)){
	   echo sprintf($t->_('The user you requested, %s, does not exist.'),$req_user);
	}
	/* Logged in user viewing own account */
	if(session::$guid==$req_user) {$own_account=true;} else{$own_account=false; session::log('200','Request account info (Requested user:'.$req_user.')');}
	/* Display requested user information */
	$req_user_info = session::getUserInfo($req_user);
	?><p><b><?php echo $t->_('Username'); ?>:</b>
	 <?php echo $req_user_info['username']; ?><br><?php
	/* Email */
	if($own_account) {
	?> <b> <?php echo $t->_('E-mail address'); ?>:</b> <?php echo $req_user_info["email"]; ?><br><?php
	}

	/**
	 * Note: when you add your own fields to the users table
	 * to hold more information, like homepage, location, etc.
	 * they can be easily accessed by the user info array.
	 *
	 * session::$userinfo["location"]; (for logged in users)
	 *
	 * ..and for this page,
	 *
	 * $req_user_info["location"]; (for any user)
	 */
	/* If logged in user viewing own account, give link to edit */
	if($own_account){
	   echo "<br><a onclick=\"openLoc('','?control=useredit','account');\">".$t->_('Edit account')."</a>";
	}
}
else if($_GET['control']=="useredit") {
	require_once('inc/utils/languageCodes.php');
	if(!isset($_POST['currpass'])&&!isset($_POST['email'])&&!isset($_GET['function'])) {
		if(session::$userinfo['password']!==NULL) { //User has a password?>
	<?php echo $t->_('Current password') ?>:<input type="password" name="currpass" maxlength="30"><br>
	<?php echo $t->_('New password'); ?>:<input type="password" name="newpass" maxlength="30" onkeyup="account.testPassword(this)"> <span style="background-image: url(<?php echo URL_STATIC; ?>/images/pwstrength/bg_strength_gradient.jpg);background-repeat: repeat-y;width: 100px;text-align: center;border: 1px solid black;display:inline-block">0%</span> <span><?php echo $t->_('Too Short'); ?></span><br>
	<?php echo $t->_('Repeat new password') ?>:<input type="password" name="newpass2" maxlength="30"><br>
	<input value="<?php echo $t->_('Change password') ?>" type="submit">
	</form></fieldset>
	<br>
	<?php } ?>
	<form method='POST' onsubmit="simplerequest.post('?control=useredit','email='+this.email.value+'&language='+$(this).find('ul').sortable('toArray').join(','),'<?php echo $t->_('Settings changed'); ?>','<?php echo $t->_('Settings could not be changed'); ?>'); return false;"><fieldset>

	<fieldset>
	<legend><?php echo $t->_('General information'); ?></legend>
	<?php echo $t->_('E-mail address'); ?>:<input type="text" name="email" maxlength="50" value="<?php echo session::$userinfo['email'];?>">
	<br>
	
	<?php
	echo $t->_('Language').':';
	$languages=unserialize(session::$userinfo['lang']);
	?>
	<ul id='user_edit_language' class='ui-state-disabled'>
		<?php foreach($languages as $language) { ?>
		<li class='ui-state-default' id='user_edit_language_<?php echo $language; ?>'><?php echo $language.': '.$languageCodes[$language]; ?></li>
		<?php } ?>
	</ul>
	<label><?php echo $t->_('Add language'); ?><select onclick='//this.blur()' onchange='$(this).parent().prev().append("<li class=\"ui-state-default\" id=\"user_edit_language_"+this.value+"\">"+this.options[this.selectedIndex].innerHTML+"</li>").sortable("refresh")'>
		<?php foreach($languageCodes as $code=>$name) {
			echo '<option value="'.$code.'">'.$code.': '.$name.'</option>';
		} ?>
	</select></label><br>
	<input type="submit" value="<?php echo $t->_('Submit settings') ?>">
	</fieldset>
	<fieldset>
	<legend><?php echo $t->_('Bound OpenIDs'); ?></legend>
	<?php $oidq=$local_connection->query('SELECT * FROM `users_openid` WHERE `link`=\''.session::$guid.'\'');
		while($oid=$oidq->fetch_assoc()) {
			echo $oid['identity'].'  <img src="'.URL_IMG.'/Silk/delete.png" alt="'.$t->_('Delete').'" title="'.$t->_('Delete this OpenID from your account').'" onclick="simplerequest.post(\'?control=useredit&function=delopenid\',\'oidhash='.$oid['hash'].'\',\''.$t->_('OpenID unlinked').'\',\''.$t->_('Error unlinking OpenID').'\',refreshCurrentTab)" class="link"><br>';
		}
	?>
	</fieldset>
	</form>
	
	</p>
<?php
	}
	elseif(isset($_POST['currpass'])) {
		$retval = session::editPass($_POST['currpass'], $_POST['newpass']);

		/* Account edit successful */
		if($retval){
			echo "true";
		}
		/* Error found with form */
		else{
			echo "false";
		}
	}
	elseif(isset($_POST['email'])) {
		if(!preg_match("/^([a-zA-Z0-9])+@([a-zA-Z0-9_-])+(\.[a-zA-Z0-9_-]+)+/",$_POST['email']))
			JSError::add($t->_('Please enter a valid e-mail address'));
		if(JSError::count()==0) {
			if(!session::updateUserField(session::$guid,'email',$_POST['email']))
				JSError::add($t->_('Error updating e-mail address'));
			$langs=explode(',',$_POST['language']);
			foreach($langs as &$lang) {
				$lang=substr($lang,-2);
			}
			if(!session::updateUserField(session::$guid,'lang',serialize($langs)))
				JSError::add($t->_('Error updating your languages'));
		}
		echo JSError::show();
	}
	elseif($_GET['function']=='delopenid') {
		if(!session::isBoundOpenId($_POST['oidhash'])) JSError::add($t->_('This OpenID is not bound'));
		if(!session::unbindOpenId($_POST['oidhash'])) JSError::add($t->_('Error unbinding the OpenID'));
		echo JSError::show();
	}
 } ?>