<?php //@./system_remote/plugins/cms/scripts.php ?>
var cms={
	page: {
		edit_title: {
			func: function(site,id,cont){
				if(cont.value!=cont.getAttribute('orig_val')) {
					simplerequest.get('?control=addons&site='+site+'&aref=cms&function=edit_title&type=page&id='+id+'&title='+cont.value,'<?php echo $t->_('Title saved'); ?>','<?php echo $t->_('Error saving title'); ?>');
				}
				else {
					cms.page.edit_title.collapse(cont);
				}
			},
			collapse: function(cont) {
				cont.parentNode.innerHTML=cont.value;
			},
			expand: function(site,id,cont) {
				inputbox=cont;
				inputbox.innerHTML='<input type=\'text\' value=\''+inputbox.innerHTML+'\' orig_val=\''+inputbox.innerHTML+'\'onblur=cms.page.edit_title.func(\''+site+'\',\''+id+'\',this)>';
				inputbox.getElementsByTagName('input')[0].focus();
			}
		},
		delete: function(site,id) {
			if(confirm('<?php echo $t->_('Do you really want to delete this page?\nAll sections will be deleted too.'); ?>')) {
				simplerequest.get('?control=addons&site='+site+'&aref=cms&function=delete&type=page&id='+id,'<?php echo $t->_('Page deleted'); ?>','<?php echo $t->_('Error deleting page'); ?>',refreshCurrentTab);
			}
		},
		edit_order: {
			up: function(site,id) {
				simplerequest.get('?control=addons&site='+site+'&aref=cms&function=move&type=page&id='+id+'&move=up','<?php echo $t->_('Page moved up'); ?>','<?php echo $t->_('Error moving page'); ?>',refreshCurrentTab);
			},
			down: function(site,id) {
				simplerequest.get('?control=addons&site='+site+'&aref=cms&function=move&type=page&id='+id+'&move=down','<?php echo $t->_('Page moved down'); ?>','<?php echo $t->_('Error moving page'); ?>',refreshCurrentTab);
			}
		},
		add: function(site) {
			simplerequest.get('?control=addons&site='+site+'&aref=cms&function=new&type=page','<?php echo $t->_('New page created'); ?>','<?php echo $t->_('Error creating page'); ?>',refreshCurrentTab);
		},
		edit_link: {
			func: function(site,id,cont){
				if(cont.value!=cont.getAttribute('orig_val')) {
					cont.value=escape(cont.value);
					simplerequest.get('?control=addons&site='+site+'&aref=cms&function=edit_link&id='+id+'&newlink='+cont.value,'<?php echo $t->_('Link saved'); ?>','<?php echo $t->_('Error saving link'); ?>',refreshCurrentTab);
				}
				else {
					cms.page.edit_link.collapse(cont);
				}
			},
			collapse: function(cont) {
				cont.parentNode.innerHTML=cont.value;
			},
			expand: function(site,id,cont) {
				inputbox=cont;
				inputbox.innerHTML='<input type=\'text\' value=\''+inputbox.innerHTML+'\' orig_val=\''+inputbox.innerHTML+'\'onblur=cms.page.edit_link.func(\''+site+'\',\''+id+'\',this)>';
				inputbox.getElementsByTagName('input')[0].focus();
			}
		},
		add_link: function(site) {
			simplerequest.get('?control=addons&site='+site+'&aref=cms&function=new&type=link','<?php echo $t->_('New link created'); ?>','<?php $t->_('Error creating link'); ?>',refreshCurrentTab);
		},
		edit_rights: {
			func: function(site,id,cont){
				if(cont.value!=cont.getAttribute('orig_val')) {
					simplerequest.get('?control=addons&site='+site+'&aref=cms&function=edit_rights&id='+id+'&rights='+cont.value,'<?php echo $t->_('Accessrights saved'); ?>','<?php echo $t->_('Error saving accessrights'); ?>',refreshCurrentTab);
				}
				else {
					cms.page.edit_rights.collapse(cont);
				}
			},
			collapse: function(cont) {
				refreshCurrentTab();
			},
			expand: function(site,id,cont,orig_rights) {
				inputbox=cont;
				HTML='<select orig_val=\''+orig_rights+'\' orig_html=\''+inputbox.innerHTML+'\' onblur=cms.page.edit_rights.func(\''+site+'\',\''+id+'\',this)><option value=\'0\'';
				if(orig_rights==0) { HTML+=' selected';}
				HTML+='><?php echo $t->_('Everyone'); ?></option><option value=\'1\'';
				if(orig_rights==1) { HTML+=' selected'; }
				HTML+='><?php echo $t->_('Users'); ?></option><option value=\'2\'';
				if(orig_rights==2) { HTML+=' selected'; }
				HTML+='><?php echo $t->_('Hidden'); ?></option></select>';
				inputbox.innerHTML=HTML;
				inputbox.getElementsByTagName('select')[0].focus();
			}
		},
		visiblity: {
			on: function(site,id) {
				simplerequest.get('?control=addons&site='+site+'&aref=cms&function=visiblity&id='+id+'&v=on','<?php echo $t->_('Page made visible'); ?>','<?php echo $t->_('Error making page visible'); ?>',refreshCurrentTab);
			},
			off: function(site,id) {
				simplerequest.get('?control=addons&site='+site+'&aref=cms&function=visiblity&id='+id+'&v=off','<?php echo $t->_('Page made invisible'); ?>','<?php echo $t->_('Error making page invisible'); ?>',refreshCurrentTab);
			}
		}
	},
	section: {
		edit_title: {
			func: function(site,id,cont) {
				if(cont.value!=cont.getAttribute('orig_val')) {
					simplerequest.get('?control=addons&site='+site+'&aref=cms&function=edit_title&type=section&id='+id+'&title='+cont.value,'<?php echo $t->_('Title saved'); ?>','<?php echo $t->_('Error saving title'); ?>');
				}
				else {
					cms.page.edit_title.collapse(cont);
				}
			},
			collapse: function(cont) {
				cont.parentNode.innerHTML=cont.value;
			},
			expand: function(site,id,cont) {
				inputbox=cont;
				inputbox.innerHTML='<input type=\'text\' value=\''+inputbox.innerHTML+'\' orig_val=\''+inputbox.innerHTML+'\' onblur=cms.section.edit_title.func(\''+site+'\',\''+id+'\',this)>';
				inputbox.getElementsByTagName('input')[0].focus();
			}
		},
		delete: function(site,id) {
			if(confirm('<?php echo $t->_('Delete section?'); ?>')) {
				simplerequest.get('?control=addons&site='+site+'&aref=cms&function=delete&type=section&id='+id,'<?php echo $t->_('Section deleted'); ?>','<?php echo $t->_('Error deleting section'); ?>',refreshCurrentTab);
			}
		},
		edit_order: {
			up: function(site,id) {
				simplerequest.get('?control=addons&site='+site+'&aref=cms&function=move&type=section&id='+id+'&move=up','<?php echo $t->_('Section moved up'); ?>','<?php echo $t->_('Error moving section'); ?>',refreshCurrentTab);
			},
			down: function(site,id) {
				simplerequest.get('?control=addons&site='+site+'&aref=cms&function=move&type=section&id='+id+'&move=down','<?php echo $t->_('Section moved down'); ?>','<?php echo $t->_('Error moving section'); ?>',refreshCurrentTab);
			}
		},
		add: function(site,pageid) {
			simplerequest.get('?control=addons&site='+site+'&aref=cms&function=new&type=section&page='+pageid,'<?php echo $t->_('New section created'); ?>','<?php echo $t->_('Error creating section'); ?>',refreshCurrentTab);
		},
		open_mce: function(site,id) {
			window.open('?control=addons&site='+site+'&aref=cms&function=mce&id='+id+'&uurl='+UURL);
		},
		switch_page: {
			func: function(site,id,newpage) {
				simplerequest.get('?control=addons&site='+site+'&aref=cms&function=switch_page&newpage='+newpage+'&id='+id,'<?php echo $t->_('Section moved'); ?>','<?php echo $t->_('Error moving section'); ?>',refreshCurrentTab);
			},
			expand: function(site,id,currpage,cont) {
				select=cont;
				prevonclick=select.getAttribute('onclick');
				select.setAttribute('prevclick',prevonclick);
				select.removeAttribute('onclick');
				select.innerHTML='<select onchange="cms.section.switch_page.func(\''+site+'\',\''+id+'\',this.value)" onblur="cms.section.switch_page.collapse(\''+site+'\',this)">'+sjax.get('?control=addons&site='+site+'&aref=cms&function=switch_page&getpages=true&currentpage='+currpage)+'</select></td>';
			},
			collapse: function(site,cont) {
				img=cont.parentNode;
				onclick=img.getAttribute('prevclick');
				img.setAttribute('onclick',onclick);
				img.removeAttribute('prevclick');
				img.innerHTML='<img src="<?php echo URL_IMG; ?>/Silk/arrow_switch.png" alt="<?php echo $t->_('Other page'); ?>" title="<?php echo $t->_('Move this section to another page'); ?>">';
			}
				
		}
	},
	sort: function(site,order_array) {
		main=order_array[0];
		sub=order_array[1];
		q='';
		for(i=0;i<main.length;i++) {
			pageid=main[i].substr(main[i].lastIndexOf('_')+1);
			q+='&order_main['+i+']='+pageid;
			thissub=sub[i]
			for(j=0;j<thissub.length;j++) {
				q+='&order_sub['+pageid+']['+j+']='+thissub[j].substr(thissub[j].lastIndexOf('_')+1);
			}
		}
		simplerequest.post('?control=addons&site='+site+'&aref=cms&function=sort','a=0'+q,'<?php echo $t->_('Pages reordered'); ?>','<?php echo $t->_('Error reordering pages'); ?>',refreshCurrentTab);
	}
}