<?php //@./system_remote/plugins/filemanager/default.php ?>
<?php
   /**
    * system/plugins/filemanager.php - RemoteCP (?control=addons&aref=filemanager)
	* Filemanager (MySQLfs)
	*
    * COPYRIGHT: remotecp.co.cc
    * COPYRIGHT 2010 remotecp.co.cc
    */
function term() {
	global $buffer,$seval;
	$buffer=ob_get_contents();
	ob_clean();
	echo "<!-- HEADERS >
<AJAX_SCRIPTLOC>a_filemanager_scripts.js</AJAX_SCRIPTLOC>
<AJAX_SCRIPTEVAL>$seval</AJAX_SCRIPTEVAL>
< HEADERS -->$buffer";
}
ob_start();
 if(!hasSiteAddonLevel()) {$session->log('403','Site access denied ('.SITE.')'); exit;} //Kill & log non-siteadmins (ze zouden hier nooit mogen geweest zijn :)
session::log('200','File access granted ('.SITE.')');
require_once('inc/fs/fs.php');
$filesystem=rdb_info::getInfo('fs');
if($filesystem=='mysqlfs') {
	require 'inc/fs/mysqlfs/mysqlfs.php';
	class valid_mysqlfs extends mysqlfs implements mysqlfs_validate {
		function valid_user_function($user) {
			return session::userExists($user);
		}
		function valid_group_function($group) {
			return groups::groupExists($group);
		}
	}
	$fs=new valid_mysqlfs($remote_connection,SITE.'_fs');
}
elseif($filesystem=='hybridfs') {
	require 'inc/fs/hybridfs/hybridfs.php';
	require 'inc/fs/ftpfs/ftpfs.php';
	list($ftp_usr,$ftp_pass,$ftp_host,$ftp_dir)=explode('|', rdb_info::getInfo('fs_ftp'));
	$ftpfs=new ftpfs($ftp_usr,$ftp_pass,$ftp_host,$ftp_dir);
	class valid_hybridfs extends mysqlfs implements HybridFS_validate {
		function valid_user_function($user) {
			return session::userExists($user);
		}
		function valid_group_function($group) {
			return groups::groupExists($group);
		}
	}
	$fs=new valid_hybridfs($remote_connection,SITE.'_fs',$ftpfs);
	unset($ftp_dir,$ftp_host,$ftp_pass,$ftp_usr,$ftpfs);
}
elseif($filesystem=='ftpfs') {
	require_once 'inc/fs/ftpfs/ftpfs.php';
	list($ftp_usr,$ftp_pass,$ftp_host,$ftp_dir)=explode('|', rdb_info::getInfo('fs_ftp'));
	$fs=new ftpfs($ftp_usr,$ftp_pass,$ftp_host,$ftp_dir);
}
$fs->setuser(session::$guid,getSiteInfo(SITE, 'ADMIN_GROUP'),groups::getMyGroups());
if(!isset($_GET['path'])) $_GET['path']='/';
$show_dir=false;
$show_file=false;
$seval="";
if(isset($_GET['action'])) {
	if($_GET['action']=="delete") {
		if($fs->is_dir($_GET['path'])) {
			if($fs->rmdir($_GET['path'])) {
				echo $t->_('Directory deleted');
			}
			else {
				echo $t->_('Error deleting directory');
			}

		}
		else {
			if($fs->unlink($_GET['path'])) {
				echo $t->_('File deleted');
			}
			else {
				echo $t->_('Error deleting file');
			}
		}
		$_GET['path']=dirname($_GET['path']);
		$show_dir=true;
	}
	if($_GET['action']=="new") {
		if($_GET['type']=="d") {
			if(!$fs->file_exists($_GET['path'].'/'.$_GET['name'])) {
				if($fs->mkdir($_GET['path'].'/'.$_GET['name'])) {
					echo "true";
				}
				else {
					echo "false|".$t->_('Error creating folder');
				}
			}
			else {
				echo "false|".$t->_('Folder already exists');
			}
		term();return;
		}
		else {
			if(!$fs->file_exists($_GET['path'].'/'.$_GET['name'])) {
				if($fs->mkfile($_GET['path'].'/'.$_GET['name'])) {
					echo "true";
				}
				else {
					echo "false|".$t->_('Error creating file');
				}
			}
			else {
				echo "false|".$t->_('File already exists');
			}
		term();return;
		}
	}
	if($_GET['action']=="edit") {
		if($fs->is_file($_GET['path'])&&!isset($_GET['abort'])) {
			if(isset($_POST['content'])) {
				if($fs->file_put_contents($_GET['path'],$_POST['content'])) {
					echo "true";
				}
				else {
					echo "false|".$t->_('Error saving the file');
				}
			term();return;
			}
			echo "
			<form action='?control=addons&site=".SITE."&aref=filemanager&action=edit&path={$fs->simplify_path($_GET['path'])}' method='POST' onsubmit='return false;'>
			<textarea name='content' style='width: 100%;height: 90%'>".htmlentities($fs->file_get_contents($_GET['path']))."</textarea>
			<input type='submit' style='width: 50%;height: 10%' onclick='filemanager.edit(\"".SITE."\",\"{$fs->simplify_path($_GET['path'])}\",this); return false;' value='".$t->_('Save')."'><input type='submit' style='width: 50%;height: 10%' name='abort' value='".$t->_('Back')."' onclick='filemanager.edit_abort(\"".SITE."\",\"{$fs->simplify_path($_GET['path'])}\")'>
			</form>
			";
			$show_dir=false;
			$show_file=false;
		}
		else {
			if(!isset($_GET['abort'])) {
				echo "false|".$t->_('The path given is not a file');
				term();return;
			}
			else {
				$_GET['path']=dirname($_GET['path']);
			}
			$show_dir=true;
		}
	}
	else if($_GET['action']=="chmod") {
		if(isset($_POST['mod'])) {
			if($fs->chmod($_GET['path'],$_POST['mod'])) {
				echo "true";
			}
			else {
				echo "false|".$t->_('Error chmodding file');
			}
			term();return;
		}
		else {
			echo "
			<form action='?control=addons&site=".SITE."&aref=filemanager&action=chmod&path={$fs->simplify_path($_GET['path'])}' method='POST' onsubmit='filemanager.chmod(\"".SITE."\",\"{$fs->simplify_path($_GET['path'])}\",this); return false;'>
			<div>
			<table>
			<thead><tr><th></th><th>".$t->_('Read')."</th><th>".$t->_('Write')."</th><th>".$t->_('Execute')."</th></tr></thead>
			<tbody>";
			$mod=$fs->getinfo($_GET['path'],'rights');
			for($i=0;$i<=2;$i++) {
				if($i==0) {
					$name=$t->_('Owner');
				}
				elseif($i==1) {
					$name=$t->_('Group');
				}
				else {
					$name=$t->_('World');
				}
				$umod=$mod[$i];
				$read=false; $write=false; $exec=false;
				if($umod>=4) {
					$read=true;
					$umod-=4;
				}
				if($umod>=2) {
					$write=true;
					$umod-=2;
				}
				if($umod>=1) {
					$exec=true;
				}
				echo "<tr><th>{$name}:</th><td><input type='checkbox' onclick='filemanager.chmod_chk.input(this.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.getElementsByTagName(\"input\")[9].value);filemanager.chmod_chk.change($i,4,this.checked);this.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.getElementsByTagName(\"input\")[9].focus()' ".($read?'checked':'')."></td><td><input type='checkbox' onclick='filemanager.chmod_chk.input(this.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.getElementsByTagName(\"input\")[9].value);filemanager.chmod_chk.change($i,2,this.checked);this.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.getElementsByTagName(\"input\")[9].focus()' ".($write?'checked':'')."></td><td><input type='checkbox' onclick='filemanager.chmod_chk.input(this.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.getElementsByTagName(\"input\")[9].value);filemanager.chmod_chk.change($i,1,this.checked);this.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.getElementsByTagName(\"input\")[9].focus()' ".($exec?'checked':'')."></td></tr>";
			}
			echo "</tbody>
			</table>
			</div>
			<input type='text' value='{$fs->getinfo($_GET['path'],'rights')}' name='mod' onfocus='filemanager.chmod_chk.output(this);filemanager.chmod_chk.checkbx(this)' onblur='filemanager.chmod_chk.input(this.value);filemanager.chmod_chk.checkbx(this)'>
			<input type='submit' value='".$t->_('Chmod')."'>
			</form>
			";
			$seval.=";filemanager.chmod_chk.input('{$fs->getinfo($_GET['path'],'rights')}');";
		}
		$_GET['path']=dirname($_GET['path']);
		$show_dir=true;
	}
	else if($_GET['action']=="chown") {
		if(isset($_POST['user'])) {
			$_POST['user']=session::getGUID($_POST['user']);
			if($fs->chown($_GET['path'],$_POST['user'])) {
				echo "true";
			}
			else {
				echo "false|".$t->_('Error chowning file');
			}
			term();return;
		}
		else {
		echo "
			<form action='?control=addons&site=".SITE."&aref=filemanager&action=chown&path={$fs->simplify_path($_GET['path'])}' method='POST' onsubmit='filemanager.chown(\"".SITE."\",\"{$fs->simplify_path($_GET['path'])}\",this); return false;'>
			<input type='text' value='".session::getUser($fs->getinfo($_GET['path'],'owner'))."' name='user'>
			<input type='submit' value='".$t->_('Chown')."'>
			</form>
			";
		}
		$_GET['path']=dirname($_GET['path']);
		$show_dir=true;
	}
	else if($_GET['action']=="chgrp") {
		if(isset($_POST['grp'])) {
			$_POST['grp']=groups::getGUID($_POST['grp']);
			if($fs->chgrp($_GET['path'],$_POST['grp'])) {
				echo "true";
			}
			else {
				echo "false|".$t->_('Error chgrping file');
			}
			term();return;
		}
		else {
		echo "
			<form action='?control=addons&site=".SITE."&aref=filemanager&action=chgrp&path={$fs->simplify_path($_GET['path'])}' method='POST' onsubmit='filemanager.chgrp(\"".SITE."\",\"{$fs->simplify_path($_GET['path'])}\",this); return false;'>
			<input type='text' value='".groups::getName($fs->getinfo($_GET['path'],'group'))."' name='grp'>
			<input type='submit' value='".$t->_('Chgrp')."'>
			</form>
			";
		}
		$_GET['path']=dirname($_GET['path']);
		$show_dir=true;
	}
	else if($_GET['action']=="upload") {
		echo "<form action='?control=addons&site=".SITE."&aref=filemanager&action=upload&path={$fs->simplify_path($_GET['path'])}&uurl=".$_SESSION['uurl']."' method='POST' enctype='multipart/form-data'>
		<input type='file' name='file'>
		<input type='submit' value='".$t->_('Upload')."'>
		</form>";
		// Check if a file has been uploaded
		if(isset($_FILES['file'])) {
			echo "<script language='JavaScript'>window.opener.filemanager.upload.complete('";

			// Make sure the file was sent without errors
			if($_FILES['file']['error'] == 0) {
				// Move uploaded file
				if($fs->move_uploaded_file($_FILES['file']['tmp_name'],$_GET['path'].'/'.$_FILES['file']['name'])) {
					echo $t->_('File uploaded');
				}
				else {
					echo $t->_('Error writing data');
				}
			}
			else {
				echo $t->_('Error sending file');
			}
			echo "'); self.close();</script>";
		}
		term();return;
		$show_dir=true;
	}
	else if($_GET['action']=="rename") {
		if(isset($_POST['newname'])) {
			if($fs->rename($_GET['path'],$_POST['newname'])){
				echo "true";
			}
			else {
				echo "false|".$t->_('Error renaming file');
			}
			term();return;
		}
		else {
			echo "
			<form action='?control=addons&site=".SITE."&aref=filemanager&action=rename&path={$fs->simplify_path($_GET['path'])}' method='POST' onsubmit='filemanager.rename(\"".SITE."\",\"{$fs->simplify_path($_GET['path'])}\",this); return false;'>
			<input type='text' value='{$_GET['path']}' name='newname'>
			<input type='submit' value='".$t->_('Rename')."'>
			</form>
			";
		}
	$_GET['path']=dirname($_GET['path']);
	$show_dir=true;
	}
	else if($_GET['action']=="copy") {
		if(isset($_POST['dest'])) {
			if($fs->copy($_GET['path'],$_POST['dest'])) {
				echo "true";
			}
			else {
				echo "false|".$t->_('Error copying file');
			}
			term();return;
		}
		else {
			echo "
				<form action='?control=addons&site=".SITE."&aref=filemanager&action=copy&path={$fs->simplify_path($_GET['path'])}' method='POST' onsubmit='filemanager.copy(\"".SITE."\",\"{$fs->simplify_path($_GET['path'])}\",this); return false;'>
				<input type='text' value='{$_GET['path']}' name='dest'>
				<input type='submit' value='".$t->_('Copy')."'>
				</form>
			";
		}
	$show_dir=true;
	$_GET['path']=dirname($_GET['path']);
	}
	else if($_GET['action']=="view") {
		ob_end_clean();
		ob_end_clean();
		ob_clean();
		header('Content-Encoding: identity'); //Disable all ob_gzhandler headers.
		ob_start();
		$fileinfo=$fs->getinfo($_GET['path']);
		header("Content-Type: ".$fileinfo['mime']);
		header("Content-Length: ".$fileinfo['size']);
		header("Last-Modified: ".$fileinfo['time']);
		header("Content-Disposition: attachment; filename=\"" . $fileinfo['filename'] . "\"");
		echo $fs->file_get_contents($_GET['path']);
		exit;
	}

}
else if($fs->is_dir($_GET['path'])) {
	$show_dir=true;
}
else if($fs->is_file($_GET['path'])) {
	$show_dir=false;
	$show_file=true;
}

#ob_start();
if($show_file) {
	$seval="window.open('?control=addons&site=".SITE."&aref=filemanager&path={$fs->simplify_path($_GET['path'])}/{$value['filename']}&action=view&uurl='+UURL)";
	$show_dir=true;
	$_GET['path']=dirname($_GET['path']);
}
if($show_dir) {
	$dir=$fs->readdir_full($_GET['path']);
	echo "<h1>".$t->_('Index of')." /{$fs->simplify_path($_GET['path'])}</h1>";
	echo "
	<form onsubmit='filemanager.new(\"".SITE."\",this); return false;'>
	<input type='hidden' name='path' value='{$fs->simplify_path($_GET['path'])}'>
	<select name='type'>
	<option value='d'>".$t->_('Folder')."</option>
	<option value='f'>".$t->_('File')."</option>
	</select>
	<input type='text' name='name' value=''>
	<input type='submit' value='".$t->_('Create')."'>
	</form>
	<input type='button' value='".$t->_('Upload')."' onclick='filemanager.upload.screen(\"".SITE."\",\"{$fs->simplify_path($_GET['path'])}\",this)'>	";
	echo "<table><thead><tr><th>".$t->_('Name')."</th><th>".$t->_('Rights')."</th><th>".$t->_('Owner')."</th><th>".$t->_('Group')."</th><th>".$t->_('Last edited')."</th><th>".$t->_('Size')."</th><th>".$t->_('Actions')."</th></tr><tr><th colspan='7'><hr></th></tr></thead><tbody>";
	foreach($dir as $value) {
		echo "<tr><td>[{$value['type']}] <a onclick=\"".(($value['type']=="d")?"openLoc('','?control=addons&site=".SITE."&aref=filemanager&path={$fs->simplify_path($_GET['path'])}/{$value['filename']}','".SITE."_ctrls_filemanager')":"window.open('?control=addons&site=".SITE."&aref=filemanager&path={$fs->simplify_path($_GET['path'])}/{$value['filename']}&action=view&uurl='+UURL); return false;")."\">{$value['filename']}</a></td><td>{$value['rights']}</td><td>".session::getUser($value['owner'])."</td><td>".groups::getName($value['group'])."</td><td>{$value['time']}</td><td>{$fs->sizetohuman($value['size'])}</td><td>
			<a onclick=\"openLoc('','?control=addons&site=".SITE."&aref=filemanager&path={$fs->simplify_path($_GET['path'])}/{$value['filename']}&action=delete','".SITE."_ctrls_filemanager')\">".$t->_('Delete')."</a>".(($value['type']=='f')?" <a onclick=\"openLoc('','?control=addons&site=".SITE."&aref=filemanager&path={$fs->simplify_path($_GET['path'])}/{$value['filename']}&action=edit','".SITE."_ctrls_filemanager')\">".$t->_('Edit')."</a>":"")." <a onclick=\"openLoc('','?control=addons&site=".SITE."&aref=filemanager&path={$fs->simplify_path($_GET['path'])}/{$value['filename']}&action=chmod','".SITE."_ctrls_filemanager')\">".$t->_('Chmod')."</a> <a onclick=\"openLoc('','?control=addons&site=".SITE."&aref=filemanager&path={$fs->simplify_path($_GET['path'])}/{$value['filename']}&action=chown','".SITE."_ctrls_filemanager')\">".$t->_('Chown')."</a> <a onclick=\"openLoc('','?control=addons&site=".SITE."&aref=filemanager&path={$fs->simplify_path($_GET['path'])}/{$value['filename']}&action=chgrp','".SITE."_ctrls_filemanager')\">".$t->_('Chgrp')."</a> <a onclick=\"openLoc('','?control=addons&site=".SITE."&aref=filemanager&path={$fs->simplify_path($_GET['path'])}/{$value['filename']}&action=rename','".SITE."_ctrls_filemanager')\">".$t->_('Rename')."</a> <a onclick=\"openLoc('','?control=addons&site=".SITE."&aref=filemanager&path={$fs->simplify_path($_GET['path'])}/{$value['filename']}&action=copy','".SITE."_ctrls_filemanager')\">".$t->_('Copy')."</a></td></tr>";
		}
	echo "</tbody></table>";
}
term();return;
?>
