<?php
/**
 * The class aggregating output from the application
 * @author Lars
 *
 */
class RESToutput {
	private $data=array();
	function __construct() {
	}
	/**
	 * Sets all data to be send
	 * @param mixed $data_object
	 * @return RESToutput
	 */
	function setData($data_object) {
		if(!is_array($data_object)) $data_object=array($data_object);
		$this->data=$data_object;
		return $this;
	}
	/**
	 * Pulls all the data inserted in this object
	 * @return mixed
	 */
	function getData() {
		return $this->data;
	}
	/**
	 * Appends data to the data already in this object
	 * @param mixed $data
	 * @return RESToutput
	 */
	function appendData($data) {
		$this->data[]=$data;
		return $this;
	}
}