<?php
define('NO_UURL', true);
header('HTTP/1.1 500 Internal Server Error');
ob_start();
function error_to_exception($enum,$estring,$efile,$eline) {
	if(error_reporting()===0) {
		return;
	}
	throw new ErrorException($estring, 0, $enum, $efile, $eline);
}
set_error_handler('error_to_exception',-1);
function shutdown() {
	if ($error = error_get_last()) {
		ob_clean();
		switch($error['type']) {
			case E_ERROR:
			case E_CORE_ERROR:
			case E_COMPILE_ERROR:
			case E_USER_ERROR:
				REST::error(500, $error['message']);
		}
	}
}
//register_shutdown_function('shutdown');
try {
	require 'REST_entry.php';
}
catch (HTTPException $e) {
	REST::error($e->getCode(), $e->getMessage());
}
try {
	REST::response()->send();
}
catch (HTTPException $e) {
	REST::error($e->getCode(), $e->getMessage());
	REST::response()->send();
}