-- phpMyAdmin SQL Dump
-- version 3.2.4
-- http://www.phpmyadmin.net
--
-- Machine: localhost
-- Genereertijd: 18 Sept 2011 om 18:48
-- Serverversie: 5.1.54
-- PHP-Versie: 5.3.5-1ubuntu7.2

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

--
-- Database: `remotecp-panel_oauth`
--

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `api_keys`
--

CREATE TABLE IF NOT EXISTS `api_keys` (
  `key` varchar(32) NOT NULL,
  `ip` int(10) NOT NULL,
  `user` char(36) NOT NULL,
  PRIMARY KEY (`key`),
  UNIQUE KEY `r` (`ip`,`user`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Gegevens worden uitgevoerd voor tabel `api_keys`
--

INSERT INTO `api_keys` (`key`, `ip`, `user`) VALUES
('39d16af94c7c098a81f2f74e4e0061ba', 2130706433, '216867cf-5b04-11e0-aca9-00262d90d787');

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `auth_consumers`
--

CREATE TABLE IF NOT EXISTS `auth_consumers` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `domain` varchar(128) NOT NULL,
  `ip` int(10) NOT NULL,
  `owner` char(36) NOT NULL,
  `shared_secret` char(40) NOT NULL,
  `name` varchar(30) NOT NULL,
  `longdesc` varchar(500) NOT NULL,
  `active` int(1) unsigned NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=2 ;

--
-- Gegevens worden uitgevoerd voor tabel `auth_consumers`
--

INSERT INTO `auth_consumers` (`id`, `domain`, `ip`, `owner`, `shared_secret`, `name`, `longdesc`, `active`) VALUES
(1, 'http://remotecp.co.cc', -1062731676, '216867cf-5b04-11e0-aca9-00262d90d787', '9c9a8c36b540dfabe037464ac2948d92e11fae2e', 'RemoteCP Root', 'This app does stuff', 1);

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `auth_granted`
--

CREATE TABLE IF NOT EXISTS `auth_granted` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user` char(36) NOT NULL,
  `consumer` int(11) unsigned NOT NULL,
  `use` int(10) unsigned NOT NULL DEFAULT '0',
  `identifier` char(40) NOT NULL,
  `until` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=4 ;

--
-- Gegevens worden uitgevoerd voor tabel `auth_granted`
--

INSERT INTO `auth_granted` (`id`, `user`, `consumer`, `use`, `identifier`, `until`) VALUES
(2, '216867cf-5b04-11e0-aca9-00262d90d787', 1, 3, '861cec59d36b4ef78f72cf46931886a0d6305c58', NULL);

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `auth_pending`
--

CREATE TABLE IF NOT EXISTS `auth_pending` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `consumer` int(11) unsigned NOT NULL,
  `use` int(10) unsigned NOT NULL DEFAULT '0',
  `tempkey` char(40) NOT NULL,
  `return_url` varchar(255) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=22 ;

--
-- Gegevens worden uitgevoerd voor tabel `auth_pending`
--


-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `messages`
--

CREATE TABLE IF NOT EXISTS `messages` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) COLLATE latin1_general_ci DEFAULT NULL,
  `message` text COLLATE latin1_general_ci NOT NULL,
  `from` varchar(30) COLLATE latin1_general_ci NOT NULL,
  `to` varchar(30) COLLATE latin1_general_ci NOT NULL,
  `from_viewed` tinyint(1) NOT NULL DEFAULT '0',
  `to_viewed` tinyint(1) NOT NULL DEFAULT '0',
  `from_deleted` tinyint(1) NOT NULL DEFAULT '0',
  `to_deleted` tinyint(1) NOT NULL DEFAULT '0',
  `from_vdate` datetime DEFAULT NULL,
  `to_vdate` datetime DEFAULT NULL,
  `from_ddate` datetime DEFAULT NULL,
  `to_ddate` datetime DEFAULT NULL,
  `created` datetime NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci AUTO_INCREMENT=1 ;

--
-- Gegevens worden uitgevoerd voor tabel `messages`
--


-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `messages_main`
--

CREATE TABLE IF NOT EXISTS `messages_main` (
  `mid` int(12) unsigned NOT NULL AUTO_INCREMENT,
  `sender` char(36) NOT NULL,
  `subject` text NOT NULL,
  `content` blob NOT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`mid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Gegevens worden uitgevoerd voor tabel `messages_main`
--


-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `messages_receivers`
--

CREATE TABLE IF NOT EXISTS `messages_receivers` (
  `mid` int(10) unsigned NOT NULL,
  `receiver` char(36) NOT NULL,
  `read` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `del` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `pdel` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`mid`,`receiver`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Gegevens worden uitgevoerd voor tabel `messages_receivers`
--


-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `remote_databases`
--

CREATE TABLE IF NOT EXISTS `remote_databases` (
  `key` varchar(32) NOT NULL,
  `host` varchar(30) NOT NULL,
  `accesstype` int(1) NOT NULL DEFAULT '0' COMMENT '0=default MySQL; 1=HTTPMySQL',
  `database` varchar(62) NOT NULL,
  `user` varchar(62) NOT NULL,
  `password` varchar(62) NOT NULL,
  `title` varchar(60) NOT NULL DEFAULT '',
  `api_link` varchar(36) NOT NULL,
  PRIMARY KEY (`key`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Gegevens worden uitgevoerd voor tabel `remote_databases`
--

INSERT INTO `remote_databases` (`key`, `host`, `accesstype`, `database`, `user`, `password`, `title`, `api_link`) VALUES
('f9fcf549ab1e708de39a51c0fcd3aee3', 'localhost', 0, 'remotecp-panel_trunk_remote', 'root', '', 'Dev database', '');

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `remote_databases_assignments`
--

CREATE TABLE IF NOT EXISTS `remote_databases_assignments` (
  `key` char(32) NOT NULL,
  `user` char(36) NOT NULL,
  `level` int(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`key`,`user`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Gegevens worden uitgevoerd voor tabel `remote_databases_assignments`
--

INSERT INTO `remote_databases_assignments` (`key`, `user`, `level`) VALUES
('f9fcf549ab1e708de39a51c0fcd3aee3', '216867cf-5b04-11e0-aca9-00262d90d787', 9);

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `serv_log`
--

CREATE TABLE IF NOT EXISTS `serv_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `type` int(3) NOT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `user` char(36) COLLATE latin1_general_ci NOT NULL,
  `ip` varchar(15) COLLATE latin1_general_ci NOT NULL,
  `url` text COLLATE latin1_general_ci NOT NULL,
  `message` text COLLATE latin1_general_ci NOT NULL,
  `flag` int(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci COMMENT='Primary server log' AUTO_INCREMENT=10 ;

--
-- Gegevens worden uitgevoerd voor tabel `serv_log`
--

INSERT INTO `serv_log` (`id`, `type`, `date`, `user`, `ip`, `url`, `message`, `flag`) VALUES
(1, 200, '2011-09-17 14:03:30', '216867cf-5b04-11e0-aca9-00262d90d787', '192.168.0.100', '/panel.php?control=login&uurl=30556624&uurl=30556624', 'User login success (CP)', 0),
(2, 200, '2011-09-18 10:19:47', '216867cf-5b04-11e0-aca9-00262d90d787', '192.168.0.100', '/panel.php?control=login&uurl=718716200&uurl=718716200', 'User login success (CP)', 0),
(3, 200, '2011-09-18 10:52:15', '216867cf-5b04-11e0-aca9-00262d90d787', '192.168.0.100', '/panel.php?control=login&uurl=718716200&uurl=718716200', 'User login success (CP)', 0),
(4, 200, '2011-09-18 10:52:54', '216867cf-5b04-11e0-aca9-00262d90d787', '192.168.0.100', '/panel.php?control=login&uurl=718716200&uurl=718716200', 'User login success (CP)', 0),
(5, 200, '2011-09-18 11:23:00', '216867cf-5b04-11e0-aca9-00262d90d787', '192.168.0.100', '/panel.php?control=login&uurl=718716200&uurl=718716200', 'User login success (CP)', 0),
(6, 200, '2011-09-18 11:50:34', '216867cf-5b04-11e0-aca9-00262d90d787', '192.168.0.100', '/panel.php?control=login&uurl=718716200&uurl=718716200', 'User login success (CP)', 0),
(7, 200, '2011-09-18 11:50:50', '216867cf-5b04-11e0-aca9-00262d90d787', '192.168.0.100', '/panel.php?control=login&uurl=718716200&uurl=718716200', 'User login success (CP)', 0),
(8, 200, '2011-09-18 12:39:09', '216867cf-5b04-11e0-aca9-00262d90d787', '192.168.0.100', '/panel.php?control=login&uurl=718716200&uurl=718716200', 'User login success (CP)', 0),
(9, 200, '2011-09-18 17:18:36', '216867cf-5b04-11e0-aca9-00262d90d787', '192.168.0.100', '/panel.php?control=login&uurl=993707572&uurl=993707572', 'User login success (CP)', 0);

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `sessions`
--

CREATE TABLE IF NOT EXISTS `sessions` (
  `sessid` varchar(32) NOT NULL,
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `usersession` char(32) NOT NULL,
  `data` text NOT NULL,
  PRIMARY KEY (`sessid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Gegevens worden uitgevoerd voor tabel `sessions`
--


-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `users`
--

CREATE TABLE IF NOT EXISTS `users` (
  `GUID` char(36) COLLATE latin1_general_ci NOT NULL,
  `username` varchar(30) COLLATE latin1_general_ci NOT NULL,
  `password` varchar(32) COLLATE latin1_general_ci DEFAULT NULL,
  `userid` varchar(32) COLLATE latin1_general_ci DEFAULT NULL,
  `userlevel` tinyint(1) unsigned NOT NULL,
  `email` varchar(50) COLLATE latin1_general_ci DEFAULT NULL,
  `timestamp` int(11) unsigned NOT NULL,
  `banned` int(1) NOT NULL DEFAULT '0',
  `lang` text CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,
  PRIMARY KEY (`GUID`),
  UNIQUE KEY `username` (`username`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

--
-- Gegevens worden uitgevoerd voor tabel `users`
--

INSERT INTO `users` (`GUID`, `username`, `password`, `userid`, `userlevel`, `email`, `timestamp`, `banned`, `lang`) VALUES
('216867cf-5b04-11e0-aca9-00262d90d787', 'admin', '21232f297a57a5a743894a0e4a801fc3', '2ba8fa2f3f6e59fb780f063189dcc629', 9, NULL, 1316360456, 0, 'a:1:{i:0;s:2:"en";}');

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `users_openid`
--

CREATE TABLE IF NOT EXISTS `users_openid` (
  `hash` char(40) NOT NULL,
  `link` char(36) NOT NULL,
  `identity` blob NOT NULL,
  PRIMARY KEY (`hash`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Gegevens worden uitgevoerd voor tabel `users_openid`
--

INSERT INTO `users_openid` (`hash`, `link`, `identity`) VALUES
('4b97fb1a96945037a7e30011070b3d5a5c19332a', '216867cf-5b04-11e0-aca9-00262d90d787', 0x68747470733a2f2f7777772e676f6f676c652e636f6d2f6163636f756e74732f6f382f69643f69643d4149744f61776e304a37396574396e67685f7438544a5f5779744279416d387548782d70375355);

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
