<?php //@./inc/httpmysql/curl.php ?>
<?php
/****************************\
| HTTPMySQL - cURL connector |
\****************************/
/**
 * Connector for HTTPMySQL
 * @package remote
 * @subpackage httpmysql
 */
class HTTPMySQL_connect {
	protected $type='cURL';
	/**
	 * Performs a post request to a remote server
	 * @param string $host The host where you want to connect to
	 * @param string $url The URI on the host to the file
	 * @param string $data The raw post string
	 * @return string Data returned by the remote file
	 */
	protected function post_request($host,$url, $data){
		$ch=curl_init("http://$host$url");
		curl_setopt($ch,CURLOPT_POST,true);
		curl_setopt($ch,CURLOPT_POSTFIELDS,$data);
		curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
		$ret=curl_exec($ch);
		curl_close($ch);
		return $ret;
	}
}