<?php //@./inc/rdb/auth.php ?><?php
/**
 * Class for remote database authentication
 */
class rdb_auth {
	static $dbid=0; //The database id number
	static $logged_in=false;
	static $level=0;
	static $exists=false;
	static function startup() {
		global $local_connection;
		self::$dbid=substr($_SERVER['PATH_INFO'],1,32);
		$dblookup=$local_connection->query('SELECT * FROM `remote_databases` WHERE `key`=\''.substr($_SERVER['PATH_INFO'],1,32).'\'');
		if($dblookup->num_rows==1)
			self::$exists=true;
		else
			return;
		if(($chkauth=self::checkauth())!==false) {
			self::$logged_in=true;
			self::$level=$chkauth;
		}
	}
	static private function checkauth() {
		global $local_connection;
		$dbaccess=$local_connection->query('SELECT * FROM `remote_databases_assignments` WHERE `key`=\''.self::$dbid.'\' AND `user`=\''.session::$guid.'\'');
		if($dbaccess->num_rows==1) {
			return $dbaccess->fetch_object()->level;
		}
	}
	static function connect() {
		if(self::checkauth()===false||self::$exists===false) return NULL;
		global $local_connection;
		$dblookup=$local_connection->query('SELECT * FROM `remote_databases` WHERE `key`=\''.self::$dbid.'\'');
		$rdbauth=$dblookup->fetch_assoc();
		if($rdbauth['accesstype']==1) {
			require_once('inc/httpmysql/httpmysql.php');
			$remote_connection=new HTTPMySQL("http://$rdbauth[user]:$rdbauth[password]@$rdbauth[host]/$rdbauth[database]/query.php"); //HTTPMySQL remote connection
		}
		else {
			$remote_connection=@new MySQLi($rdbauth['host'],$rdbauth['user'],$rdbauth['password'],$rdbauth['database']);
		}
		if(!@$remote_connection->ping()) {
			trigger_error('Could not connect to the remote database',E_USER_ERROR);
		}
		return $remote_connection;
	}
}
rdb_auth::startup();