<?php //@./inc/sitemgmt/constants.php ?>
<?php
/**
 * This file sets all configuration for RemoteCP Panel
 * @package core
 * Resource Constants - these constants take care of
 * the location of the images and CSS-sheets.
 * If these locations are incorrect, there won't
 * be any lay-out, images, site title or correct RSS.
 */
define("DOMAIN","http://account.loop.remotecp.co.cc/");
define("URL_STATIC",DOMAIN."/static/");
define("URL_IMG", URL_STATIC."/images/icons/"); //Images location
define("URL_TINYMCE", DOMAIN."/tinymce/jscripts/"); //Tinymce's javascript library location
define("URL_JQUERY", DOMAIN."/jquery/"); //Jquery's javascript library location
define("URL_SCRIPTS",DOMAIN."/scripts");
/**
 * Database Constants - these constants are required
 * in order for there to be a successful connection
 * to the MySQL database. Make sure the information is
 * correct.
 */
define("DB_SERVER", "localhost");
define("DB_USER", "root");
define("DB_PASS", "");
define("DB_NAME", "remotecp-panel_trunk");

$local_connection=new MySQLi(DB_SERVER,DB_USER,DB_PASS,DB_NAME);
?>
