<?php
/**
 * Simple POST handler
 * @package utils
 */
if(function_exists('curl_open')) {
	function post($host,$url,$data) {
		$ch=curl_init("http://$host$url");
		curl_setopt($ch,CURLOPT_POST,true);
		curl_setopt($ch,CURLOPT_POSTFIELDS,$data);
		curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
		$ret=curl_exec($ch);
		curl_close($ch);
		return $ret;
	}
}
else {
	function post($host,$url,$data) {
		$fp = fsockopen($host, 80);
		if(!$fp) {
			trigger_error('Error opening connection to '.$host,E_USER_WARNING);
			return false;
		}
		$out = "POST $url HTTP/1.1\r\n";
		$out .= "Host: $host\r\n";
		$out .= "Content-Type: application/x-www-form-urlencoded\r\n";
		$out .= "Content-Length: ".strlen($data)."\r\n";
		$out .= "Connection: Close\r\n\r\n";
		$out .= $data;
		fwrite($fp, $out);
		$ret="";
		while (!feof($fp)) {
			$ret.= fgets($fp,1024);
		}
		fclose($fp);
		$headers=substr($ret,0,strpos($ret,"\r\n\r\n"));
		$hret=array();
		$headers=explode("\r\n",$headers);
		foreach($headers as $header) {
			$header=explode(': ',$header);
			if(!isset($header[1])) $hret[]=$header[0];
			else $hret[$header[0]]=$header[1];
		}
		$headers=$hret;
		$ret=substr($ret,strpos($ret,"\r\n\r\n")+4);
		if(substr($headers[0],9,3)!=200) trigger_error('Error establishing connection to http://'.$host.'/'.$url.': Server returned '.$headers[0],E_USER_WARNING);
		return $ret;
	}
}