<?php
function is_valid_domain_name($domain_name)
{
    $pieces = explode(".",$domain_name);
    if(count($pieces)<2) return false;
    foreach($pieces as $piece)
    {
        if (!preg_match('/^[a-z\d][a-z\d-]{0,62}$/i', $piece)
            || preg_match('/-$/', $piece) )
        {
            return false;
        }
    }
    return true;
}
