<?php
//define('__DEBUG__',true);
define('NO_UURL',true);
require('inc/controllers.php');
require_once('inc/utils/post.php');
if(isset($_GET['logout'])) {
	session::logout();
	echo $t->_('You can close this window now');
	echo '<script>self.close()</script>';
}
if(!isset($_REQUEST['app_auth'])) {
	die($t->_('No such application authorisation code exists'));
}
if(isset($_POST['user'],$_POST['password'])) {
	if(!session::login($_POST['user'],$_POST['password'])) {
		JSError::add($t->_('We could not log you in'));
	}
	
}
if(session::$logged_in) {
	$currsess=session_id();
	session_commit();
	session_id($_REQUEST['app_auth']);
	session_start();
	if(!isset($_SESSION['app'])) {
		die($t->_('No such application authorisation code exists'));
	}
	$appinfo=$_SESSION['app'];
	session_commit();
	session_id($currsess);
	session_start();
	if(isset($_POST['app_ok'])) { //The user allowed authorizing
		session_commit();
		$usersession=session_id();
		session_start();
		$_SESSION['sesslink']=$usersession;
		$_SESSION['servip']=post($appinfo['dom'],$appinfo['landing'].'?request_ip','for=bind');
		session_commit();
		$bindid=post($appinfo['dom'],$appinfo['landing'].'?request_bind','for='.session_id());
		header('HTTP/1.1 307 Temporary Redirect');
		header('Location: http://'.$appinfo['dom'].$appinfo['landing'].'?bind='.$bindid);
	}
	if(isset($_POST['app_cancel'])) { //Cancel authorizing
		echo $t->_('You can close this window now');
		echo "<script>self.close()</script>";
	}
	echo '<!DOCTYPE >';
	echo '<html><head><title>RemoteCP</title></head><body>';
	echo '<script>window.resizeTo(400,350);</script>';
	echo '<form action="?logout" style="float: right">'.session::$username.' &bull; <input type="submit" value="'.$t->_('Log out').'"></form>';
	echo '<form method="POST">';
	echo '<h1>'.sprintf($t->_('Do you want to log in to %s?'),htmlentities($appinfo['name'])).'</h1>';
	echo '<div>';
	echo '<h2>'.htmlentities($appinfo['name']).'</h2>';
	echo '<p>'.$t->_('By').' '.htmlentities($appinfo['dom']).'</p>';
	echo '<p>'.htmlentities($appinfo['desc']).'</p>';
	echo '</div>';
	echo '<div style="clear: right;">';
	echo '<input type="hidden" name="app.auth" value="'.htmlentities($_REQUEST['app_auth']).'">';
	echo '<input type="submit" name="app.ok" value="'.$t->_('Log in to this site').'">';
	echo '<input type="submit" name="app.cancel" value="'.$t->_('I don\'t want to go there').'")">';
	echo '<!--<br>';
	echo '<input type="submit" name="app.always.allow" value="'.$t->_('Always log in to this site').'">';
	echo '<input type="submit" name="app.always.deny" value="'.$t->_('Never log in to this site').'">-->';
	echo '</div>';

	echo '</form></body></html>';

}
else {
	echo '<!DOCTYPE >';
	echo '<html><head><title>RemoteCP</title></head><body>';
	if(JSError::count()!=0) {
		echo '<ul>';
		$es=JSError::get();
		foreach($es as $e) {
			echo '<li>'.$e.'</li>';
		}
		echo '</ul>';
	}
	echo '<form method="POST">';
	echo '<label>'.$t->_('Username').': <input name="user" type="text"></label><br>';
	echo '<label>'.$t->_('Password').': <input name="password" type="password"></label><br>';
	echo '<input type="hidden" name="app.auth" value="'.htmlentities($_REQUEST['app_auth']).'">';
	echo '<input type="submit" value="'.$t->_('Log in').'">';
	echo '</form>';
	echo '</body></html>';
}
?>