<?php
define('NO_UURL',true);
define('__DEBUG__',true);
$identity='';
$attributes=array();
chdir(__DIR__.'/..'); // Our root is at the parent directory!
require 'inc/controllers.php';
require 'inc/openid/rp.php';
try {
    $openid = new LightOpenID;
    if(!$openid->mode) {
        if(isset($_POST['openid_identifier'])) {
            $openid->identity = $_POST['openid_identifier'];
            $openid->optional=array('pref/language','contact/email','namePerson/friendly');
            header('Location: ' . $openid->authUrl());
            exit;

        }
?>
	<form action="/openid/login.php" target="_blank" method="post" id="openid_form" onsubmit="$(this).parent().showLoading();">
		<input type="hidden" name="action" value="verify" />
			<div id="openid_choice">
				<p>Please click your account provider:</p>
				<div id="openid_btns"></div>
			</div>
			<div id="openid_input_area">
				<input id="openid_identifier" name="openid_identifier" type="text" value="http://" />
				<input id="openid_submit" type="submit" value="Sign-In"/>
			</div>
	</form>
<?php
    } elseif($openid->mode == 'cancel') {
        echo '<script>window.opener.$("#openid_form").parent().hideLoading();window.opener.notice.error("OpenID login cancelled","If you didn\'t cancel authentication, contact your provider");self.close()</script>';
    } else {
    	$v=$openid->validate();
        $identity=$openid->identity;
        $attributes=$openid->getAttributes();
        if(!session::isBoundOpenId(sha1($identity))) {
        	echo '<script>window.opener.$("#openid_form").parent().hideLoading();window.opener.$("#dlg_openid").html("This OpenID is not yet bound to any account.<br><a onclick=\'$(\"#dlg_openid\").load(\"openid/create_account.php\")\' class=\'link\'>Create an account</a> or <a onclick=\'$(\"#dlg_openid\").load(\"openid/link_account.php\")\' class=\'link\'>link</a> this OpenID to your account.").dialog(\'moveToTop\');self.close()</script>';
        }
        else {
        	echo '<script>window.opener.$("#openid_form").parent().hideLoading();window.opener.refreshFrames();window.opener.$("#dlg_openid").dialog("destroy").detach();window.opener.notice.message("OpenID auto login successful","'.$_SESSION['openid']['identity'].'");window.opener.$("#dlg_log-in").dialog("close");self.close();</script>';
        }
        $_SESSION['auth_type']='openid';
        $_SESSION['openid']['identity']=$identity;
        $_SESSION['openid']['attributes']=$attributes;
        session::init();

    }
} catch(ErrorException $e) {
    echo $e->getMessage();
}

