<?php
require_once('inc/errorhandler.php');
if (get_magic_quotes_gpc()) { //Disable & remove magic quotes ! (http://www.php.net/manual/en/security.magicquotes.disabling.php: example 2)
	$process = array(&$_GET, &$_POST, &$_COOKIE, &$_REQUEST);
	while (list($key, $val) = each($process)) {
		foreach ($val as $k => $v) {
			unset($process[$key][$k]);
			if (is_array($v)) {
				$process[$key][stripslashes($k)] = $v;
				$process[] = &$process[$key][stripslashes($k)];
			} else {
				$process[$key][stripslashes($k)] = stripslashes($v);
			}
		}
	}
	unset($process);
}
require_once('inc/sitemgmt/constants.php');
require_once('inc/API_keys/keycheck.php');
$keycheck=new api_key_check($local_connection,'api_keys');
$result=array();
if(!isset($_POST['api_key'])||!$keycheck->checkkey($_POST['api_key'],$_SERVER['REMOTE_ADDR'])){
	header('HTTP/1.1 401 Unauthorized'); //Get out, you don't have a valid API-key
	$result['Status']=false;
	$result['ErrorCode']=1;
	$result['Error']='Please provide a valid API key';
	$result['GUID']=NULL;
}
else if(!isset($_POST['username'])) {
	header('HTTP/1.1 400 Bad Request'); //We don't understand you, you don't give a session?
	$result['Status']=false;
	$result['ErrorCode']=2;
	$result['Error']='Please provide a username';
	$result['GUID']=NULL;
}
else {
	require 'inc/users/users.php';
	session::log(200, $_SERVER['REMOTE_ADDR'].' requested GUID of '.$_POST['username']);
	header('HTTP/1.1 200 OK');
	$result['Status']=true;
	$result['ErrorCode']=0;
	$result['Error']=NULL;
	if(!session::userExists($_POST['username'],1)) {
		$result['GUID']=NULL;
	}
	else {
		$result['GUID']=session::getGUID($_POST['username']);
	}
}

echo serialize($result);