function tableToSortable(obj,useCell,sortprops) {
	id=obj.attr('id');
	if(id==undefined||id=='') {
		id=Math.round(Math.random()*10E16);
		obj.attr('id',id);
	}
	rows=obj.find('tr').get();
	mainclass=obj.attr('class');
	if(mainclass==undefined) {
		mainclass='';
	}
	html='';
	for(i=0;i<rows.length;i++) {
		cell=$(rows[i]).children('td').get(useCell);
		if(cell==undefined) continue;
		origclass=$(rows[i]).attr('class');
		if(origclass==undefined) {
			origclass='';
		}
		if(origclass.indexOf('gui-nosort')!=-1) origclass+=' ui-state-disabled';
		origid=$(rows[i]).attr('id');
		orightml=$(cell).html();
		html+='<li class="'+origclass+' ui-state-default" id="'+origid+'">'+orightml+'</li>';
	}
	obj.after('<ul class="'+mainclass+'" id="'+id+'_new" style="display: none; width: 200px">'+html+'</ul>');
	obj.hide('blind','slow',function() {
		obj.detach();
		$('#'+id+'_new').attr('id',id);
	});
	$('#'+id+'_new').sortable(sortprops);
	$('#'+id+'_new').show('blind','slow');
}
function multiSortableToArray(obj) {
	end=new Array();
	main=obj.sortable('toArray');
	for(i=0;i<main.length;i++) {
		sub=$('#'+main[i]+' .sub-sortable').sortable('toArray');
		end.push(sub);
	}
	return new Array(main,end);
}