<!-- HEADERS >
<AJAX_SCRIPTLOC>mail_scripts.js</AJAX_SCRIPTLOC>
<AJAX_SCRIPTEVAL>NULL</AJAX_SCRIPTEVAL>
< HEADERS -->
<?php
require_once 'inc/users/mail.php';
require_once 'inc/utils/time_ago.php';
$mail=new mail($local_connection,session::$guid);
if(!isset($_GET['function'])) {
	$_GET['function']='inbox';
}
//Mail navigation
if($_GET['function']=='inbox'||$_GET['function']=='outbox'||$_GET['function']=='deleted') {
	echo '<ul style="padding:0px; list-style: none">'
	.'<li onclick="mail.inbox(this)" style="display: inline; margin: 5px;" class="link" data-active='.($_GET['function']=='inbox'?'1':'0').'>'.$t->_('Inbox').'</li>'
	.'<li onclick="mail.outbox(this)" style="display: inline; margin: 5px;" class="link" data-active='.($_GET['function']=='outbox'?'1':'0').'>'.$t->_('Outbox').'</li>'
	.'<li onclick="mail.deleted(this)" style="display: inline; margin: 5px;" class="link" data-active='.($_GET['function']=='deleted'?'1':'0').'>'.$t->_('Deleted').'</li>'
	.'<li onclick="mail.compose()" style="display: inline; margin: 5px;" class="link" data-active=0>'.$t->_('Compose message').'</li>'
	.'</ul>';
}
//Content
if($_GET['function']=='inbox') {
	$messages=$mail->getInbox();
	echo '<table><tr><th></th><th>'.$t->_('Sender').'</th><th>'.$t->_('Title').'</th><th>'.$t->_('Received').'</th><th>'.$t->_('Actions').'</tr>';
	foreach($messages as $message){
		$msginfo=$mail->getMessage($message);
		echo '<tr><td><img src="'.URL_IMG.'/Silk/email'.($msginfo['read']==0?'':'_open').'.png"></td><td>'.session::getUser($msginfo['sender']).'</td><td class="link" onclick="mail.open(\''.$message.'\')">'.$msginfo['subject'].'</td><td>'.time_ago(strtotime($msginfo['date'])).'</td><td>'
		.'<img class="link" src="'.URL_IMG.'/Silk/delete.png" alt="'.$t->_('Delete').'" title="'.$t->_('Delete this message').'" onclick="mail.delete(\''.$message.'\',this);">'
		.'</td></tr>';
	}
	echo '</table>';
}
elseif($_GET['function']=='outbox') {
	$messages=$mail->getSent();
	echo '<table><tr><th></th><th>'.$t->_('Receivers').'</th><th>'.$t->_('Title').'</th><th>'.$t->_('Send').'</td></tr>';
	foreach($messages as $message){
		$msginfo=$mail->getMessage($message);
		$receivers=$mail->getReceivers($message);
		$recstr='';
		foreach($receivers as $receiver) {
			$recstr.=', '.session::getUser($receiver);
		}
		$recstr=substr($recstr, 2);
		echo '<tr onclick="mail.open(\''.$message.'\')"><td><img src="'.URL_IMG.'/Silk/email_go.png"></td><td>'.$recstr.'</td><td>'.$msginfo['subject'].'</td><td>'.time_ago(strtotime($msginfo['date'])).'</td></tr>';
	}
	echo '</table>';
}
elseif($_GET['function']=='deleted') {
	$messages=$mail->getDeleted();
	echo '<table><tr><th></th><th>'.$t->_('Sender').'</th><th>'.$t->_('Title').'</th><th>'.$t->_('Received').'</th><th>'.$t->_('Actions').'</th></tr>';
	foreach($messages as $message){
		$msginfo=$mail->getMessage($message);
		echo '<tr><td><img src="'.URL_IMG.'/Silk/email'.($msginfo['read']==0?'':'_open').'.png"></td><td>'.session::getUser($msginfo['sender']).'</td><td class="link" onclick="mail.open(\''.$message.'\')">'.$msginfo['subject'].'</td><td>'.time_ago(strtotime($msginfo['date'])).'</td><td>'
		.'<img class="link" src="'.URL_IMG.'/Silk/delete.png" alt="'.$t->_('Delete').'" title="'.$t->_('Delete this message').'" onclick="mail.delete(\''.$message.'\',this);">'
		.'</td></tr>';
	}
	echo '</table>';
}
elseif($_GET['function']=='read') {
	$message=$mail->read($_GET['id']);
	echo '<p style="padding-left: 10px">'.$t->_('From').': '.session::getUser($message['sender']).'<br>'
	.$t->_('To').': ';
	$recvs='';
	foreach($message['receivers'] as $receiver){
		$recvs.=', '.session::getUser($receiver);
	}
	echo substr($recvs,2).'<br>'
	.$t->_('Subject').': <b>'.$message['subject'].'</b><br>'
	.$t->_('Date').': '.$message['date'].'<hr></p>'
	.$message['content'];
}
elseif($_GET['function']=='compose') {
	if(isset($_POST['receivers'])) {
		$receivers=explode(',', $_POST['receivers']);
		foreach($receivers as &$receiver) {
			if(!session::userExists($receiver,1)) {
				JSError::add(sprintf($t->_('The user %s does not exist'),$receiver));
				continue;
			}
			$receiver=session::getGUID($receiver);
		}
		require_once 'inc/utils/htmlsanitizer.php';
		if(!$mail->send($receivers, $_POST['subject'], html_sanitize($_POST['compose-mail']))) JSError::add($t->_('Database failure'));
		echo JSError::show();
	}
	elseif(isset($_GET['reply'])) {
		if($_GET['get']=='body') {
		$minfo=$mail->getMessage($_GET['reply']);
		echo '<p></p><div style="padding-left: 10px;"><p>'.sprintf($t->_('Reply to message of %1$s on %2$s'),session::getUser($minfo['sender']),$minfo['date']).'</p>'
				.htmlentities($minfo['content']).'</div>';
		}
		elseif($_GET['get']=='receivers') {
			$minfo=$mail->getMessage($_GET['reply']);
			$receivers=array_merge(array($minfo['sender']),$mail->getReceivers($_GET['reply']));
			$receivers=array_unique($receivers);
			foreach($receivers as &$receiver) {
				$receiver=array('label'=>session::getUser($receiver));
			}
			echo json_encode($receivers);
		}
		elseif($_GET['get']=='sender'){
			$minfo=$mail->getMessage($_GET['reply']);
			echo json_encode(array(array('label'=>session::getUser($minfo['sender']))));
		}
		elseif($_GET['get']=='subject') {
			$minfo=$mail->getMessage($_GET['reply']);
			echo 'RE: '.$minfo['subject'];
		}
	}
}
elseif($_GET['function']=='delete') {
	if($mail->delete($_POST['id'])) echo 'true';
	else echo 'false';
}