<?php //@./system_local/create_site.php ?>
<!-- HEADERS >
<AJAX_SCRIPTLOC>create_site_scripts.js</AJAX_SCRIPTLOC>
<AJAX_SCRIPTEVAL>NULL</AJAX_SCRIPTEVAL>
< HEADERS --><?php
/**
* create_site.php - Jquery UI control panel (?control=create_site)
* require_once in CP
*
* CREATED BY remotecp.co.cc
* COPYRIGHT 2010 remotecp.co.cc
*/
require_once('inc/utils/doubleExplode.php');
require_once('inc/utils/guid.php');
require_once 'inc/utils/languageCodes.php';
if(isset($_POST['domain'])) {
	$_POST['sub']=strtolower($_POST['sub']); $_POST['domain']=strtolower($_POST['domain']); //Lowercase only
	if(trim($_POST['title'])=="") { JSError::add($t->_('You must provide a site title')); } //Check title length
	if(!preg_match('/^[a-z0-9]+$/',$_POST['sub'])) { JSError::add($t->_('Your subdomain must consist of at least one alphanumeric character')); } //Subdomain must be (alpha-)numeric
	//Check domain
	$domcheck=$remote_connection->query('SELECT * FROM `system_domains` WHERE `url-in`=\''.$_POST['sub'].'.'.$_POST['domain'].'\'');
	if($domcheck->num_rows!=0) { JSError::add($t->_('This domain already is registered')); } //Domain name exists
	if(JSError::count()!=0) {
		echo JSError::show();
		return;
	}
	$x=array();
	$site_ref=guid(); //Make a random site ref
	//Create domain link
	$x[]=$remote_connection->query('INSERT INTO `system_domains` VALUES(\''.$remote_connection->escape_string($_POST['sub'].'.'.$_POST['domain']).'\',NULL,\''.$site_ref.'\')');
	//Create site constants
	$x[]=$remote_connection->query('INSERT INTO `system_siteinfo` VALUES(\''.$site_ref.'\',\'SITE_TITLE\',\''.$remote_connection->escape_string(htmlspecialchars($_POST['title'])).'\')');
	$x[]=$remote_connection->query('INSERT INTO `system_siteinfo` VALUES(\''.$site_ref.'\',\'URL_SITE\',\'http://'.$remote_connection->escape_string($_POST['sub'].'.'.$_POST['domain']).'/\')');
	$x[]=$remote_connection->query('INSERT INTO `system_siteinfo` VALUES(\''.$site_ref.'\',\'SITE_AUTHOR\',\''.$remote_connection->escape_string(htmlspecialchars($_POST['author'])).'\')');
	$x[]=$remote_connection->query('INSERT INTO `system_siteinfo` VALUES(\''.$site_ref.'\',\'SITE_SLOGAN\',\''.$remote_connection->escape_string(htmlspecialchars($_POST['slogan'])).'\')');
	$x[]=$remote_connection->query('INSERT INTO `system_siteinfo` VALUES(\''.$site_ref.'\',\'SITE_CSS\',\''.$remote_connection->escape_string($_POST['style']).'\')');
	$x[]=$remote_connection->query('INSERT INTO `system_siteinfo` VALUES(\''.$site_ref.'\',\'SITE_LNG\',\''.$remote_connection->escape_string($_POST['lang']).'\')');
	$x[]=$remote_connection->query('INSERT INTO `system_siteinfo` VALUES(\''.$site_ref.'\',\'SITE_FOOTER\',\''.$remote_connection->escape_string($_POST['foot']).'\')');
	$x[]=$remote_connection->query('INSERT INTO `system_siteinfo` VALUES(\''.$site_ref.'\',\'ADMIN_GROUP\',NULL)');
	
	//Create site addons index
	$x[]=$remote_connection->query("CREATE TABLE `{$site_ref}_addons` (`name` varchar(30) NOT NULL,`reference` varchar(30) NOT NULL,`status` int(1) NOT NULL default '0',`gid` char(36) NULL default NULL,`editable` int(1) NOT NULL default '1') ENGINE=MyISAM DEFAULT CHARSET=latin1");
	$q=$remote_connection->query('SELECT * FROM `_system_` WHERE `key`=\'addons\''); //Get installed addons
	$prepared_q="INSERT INTO `{$site_ref}_addons` (`name`, `reference`, `status`, `gid`, `editable`) VALUES ('CMS', 'cms', 1, NULL, 0),('Column1', 'col1', 1, NULL, 0),('Column 3', 'col3', 1, NULL, 0),('File manager', 'filemanager', 1, NULL, 0)";
	$q=$q->fetch_assoc();
	$q['value']=preg_replace('@^&?(.*)&?$@', '$1', $q['value']);
	$addons=doubleExplode('&','=',$q['value']);
	foreach($addons as $name=>$addon) {
		$prepared_q.=",('$name', '$addon', 0, NULL, 1)";
	}
	$x[]=$remote_connection->query($prepared_q); //Dump addons into table
	//Create col1 table
	$x[]=$remote_connection->query("CREATE TABLE `{$site_ref}_col1` ( `id` int(11) NOT NULL AUTO_INCREMENT, `order` int(5) NOT NULL, `title` varchar(30) NOT NULL, `content` text NOT NULL, `plugin-reference` varchar(30) DEFAULT NULL, `access` int(1) NOT NULL DEFAULT '0', PRIMARY KEY (`id`)) ENGINE=MyISAM DEFAULT CHARSET=latin1");
	$remote_connection->query("TRUNCATE TABLE `{$site_ref}_col1`"); //Clean table
	//Dump col1 contents into table
	//No contents
	//Create col3 table
	$x[]=$remote_connection->query("CREATE TABLE `{$site_ref}_col3` ( `id` int(11) NOT NULL AUTO_INCREMENT, `order` int(5) NOT NULL, `title` varchar(30) NOT NULL, `content` text NOT NULL, `plugin-reference` varchar(30) DEFAULT NULL, `access` int(1) NOT NULL DEFAULT '0', PRIMARY KEY (`id`)) ENGINE=MyISAM DEFAULT CHARSET=latin1");
	$remote_connection->query("TRUNCATE TABLE `{$site_ref}_col3`"); //Clean table
	//Dump col3 contents into table
	//No contents
	//Create pageindex table
	$x[]=$remote_connection->query("CREATE TABLE `{$site_ref}_pageindex` ( `id` int(5) NOT NULL AUTO_INCREMENT, `type` int(1) NOT NULL DEFAULT '0', `page_order` int(5) NOT NULL, `page_title` text COLLATE latin1_general_ci NOT NULL, `link` text COLLATE latin1_general_ci NOT NULL, `access` int(1) NOT NULL DEFAULT '0', `visible` int(11) NOT NULL DEFAULT '1', PRIMARY KEY (`id`)) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;");
	$remote_connection->query("TRUNCATE TABLE `{$site_ref}_pageindex`"); //Clean table
	//Dump pageindex contents into table
	$x[]=$remote_connection->query("INSERT INTO `{$site_ref}_pageindex` (`id`, `type`, `page_order`, `page_title`, `link`, `access`, `visible`) VALUES(1, 2, 1, 'Home', '', 0, 1)");
	//Create pages tables
	$x[]=$remote_connection->query("CREATE TABLE `{$site_ref}_pages` ( `id` int(11) NOT NULL AUTO_INCREMENT, `page_id` int(5) NOT NULL, `section_order` int(11) NOT NULL DEFAULT '1', `section_title` text COLLATE latin1_general_ci NOT NULL, `section_main` text COLLATE latin1_general_ci NOT NULL, `plugin-reference` varchar(30) COLLATE latin1_general_ci DEFAULT NULL, PRIMARY KEY (`id`)) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci");
	$remote_connection->query("TRUNCATE TABLE `{$site_ref}_pages`"); //Clean table
	//Dump pages contents into table
	//No contents
	//Create MySQLfs index table
	$x[]=$remote_connection->query("CREATE TABLE `{$site_ref}_fs` (`path` varchar(900) NOT NULL,`filename` varchar(100) NOT NULL,`rights` int(3) unsigned zerofill NOT NULL DEFAULT '777',`owner` char(36) DEFAULT NULL,`group` char(36) DEFAULT NULL,`time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,`type` enum('d','f') NOT NULL,`mime` varchar(100) NOT NULL DEFAULT 'application/octet-stream',`size` int(11) unsigned NOT NULL DEFAULT '0',`mfi` int(11) unsigned NOT NULL AUTO_INCREMENT,UNIQUE KEY `path` (`path`,`filename`),UNIQUE KEY `mfi` (`mfi`)) ENGINE=MyISAM");
	//Dump MySQLfs primary folder
	$x[]=$remote_connection->query("INSERT INTO `{$site_ref}_fs` (`path`, `filename`, `rights`, `owner`, `group`, `time`, `type`, `mime`, `size`, `mfi`) VALUES('/', '', 777, NULL, NULL, NULL, 'd', 'application/octet-stream', 0, 1);");
	//Create MySQLfs data table
	$x[]=$remote_connection->query("CREATE TABLE `{$site_ref}_fsdata` (`id` int(11) unsigned NOT NULL AUTO_INCREMENT,`masterid` int(11) unsigned NOT NULL,`data` blob NOT NULL,PRIMARY KEY (`id`),KEY `masterid` (`masterid`)) ENGINE=MyISAM");
	//Assign admin link
	$x[]=$remote_connection->query("INSERT INTO `sites` VALUES ('".session::$guid."', '{$site_ref}', '')");
	//Ready...
	if(in_array(false,$x)) { JSError::add($t->_('Something went wrong')); }
	echo JSError::show();

}
else {
	?>
	<form onsubmit='create_site.send(this); return false;' method='POST'>
	<fieldset>
	<legend><?php echo $t->_('General'); ?></legend>
	<label><?php echo $t->_('Domain'); ?>: <input name='sub'>.</label>
	<select name='domain'>
	<?php $q=$remote_connection->query('SELECT * FROM `_system_` WHERE `key`=\'domains\'');
	$q=$q->fetch_assoc();
	$domains=explode('|',$q['value']);
	foreach($domains as $domain) {
		echo "
		<option value='$domain'>$domain</option>";
	} ?>

	</select>
	<br>
	<label><?php echo $t->_('Style'); ?>:
	<select name='style'><?php
	$q=$remote_connection->query('SELECT * FROM `_system_` WHERE `key`=\'styles\'');
	$q=$q->fetch_assoc();
	$styles=explode('|',$q['value']);
	foreach($styles as $style) {
		echo "
		<option value='$style'>$style</option>";
	}?>

	</select>
	</label><br>
	<label><?php echo $t->_('Language'); ?>:
	<select name='lang'>
	<?php
	foreach($languageCodes as $code=>$lang) {
		echo "<option value='$code'>$code: $lang</option>";
	}
	?>
	</select></label>
	</fieldset>
	<fieldset>
	<legend><?php echo $t->_('Content'); ?></legend>
	<label><?php echo $t->_('Site title'); ?>: <input name='title'></label><br>
	<label><?php echo $t->_('Site tagline'); ?>: <input name='slogan'></label><br>
	<label><?php echo $t->_('Site footer'); ?>: <input name='foot'></label><br>
	<label><?php echo $t->_('Author'); ?>: <input name='author'></label>
	</fieldset>
	<input type="Submit">
	</form>

	
<?php } ?>