<?php //@./system_remote/plugins/cms/api.php ?>
<?php
class cms {
	static function get_pages() {
		global $remote_connection;
		$q=$remote_connection->query('SELECT * FROM `'.SITE.'_pageindex` ORDER BY `page_order` ASC');
		$PAGES=array();
		while($page=$q->fetch_assoc()) {
			$PAGES[]=$page;
		}
		return $PAGES;
	}
	static function get_page($id) {
		global $remote_connection;
		return $remote_connection->query('SELECT * FROM `'.SITE.'_pageindex` WHERE `id`='.$id)->fetch_assoc();
	}
	static function get_sections($page_id) {
		global $remote_connection;
		$q=$remote_connection->query('SELECT * FROM `'.SITE.'_pages` WHERE `page_id`='.$page_id.' ORDER BY `section_order` ASC');
		$SECTIONS=array();
		while($section=$q->fetch_assoc()) {
			$SECTIONS[]=$section;
		}
		return $SECTIONS;
	}
	static function get_section($id) {
		global $remote_connection;
		return $remote_connection->query('SELECT * FROM `'.SITE.'_pages` WHERE `id`='.$id)->fetch_assoc();
	}
	static function delete_page($id) {
		global $remote_connection;
		$remote_connection->query('DELETE FROM `'.SITE.'_pageindex` WHERE `id`='.$id);
		$remote_connection->query('DELETE FROM `'.SITE.'_pages` WHERE `page_id`='.$id);
		return true;
	}
	static function delete_section($id) {
		global $remote_connection;
		return $remote_connection->query('DELETE FROM `'.SITE.'_pages` WHERE `id`='.$id);
	}
	static function add_page($props=array()) {
		global $remote_connection;
		$defaults=array('type'=>0,'page_title'=>'API_added_page','link'=>'','access'=>0,'visible'=>1);
		$props=array_merge($defaults,$props);
		$order=$remote_connection->query('SELECT * FROM `'.SITE.'_pageindex` ORDER BY `page_order` DESC')->fetch_assoc();
		$order=$order['page_order']+1;
		if(!$remote_connection->query('INSERT INTO `'.SITE.'_pageindex` VALUES(NULL,'.$props['type'].','.$order.',\''.$props['page_title'].'\',\''.$props['link'].'\','.$props['access'].','.$props['visible'].')')) return false;
		return $remote_connection->insert_id;
	}
	static function add_section($page_id,$props=array()) {
		global $remote_connection;
		$defaults=array('section_title'=>'API_added_section','section_main'=>'','plugin-reference'=>'');
		$props=array_merge($defaults,$props);
		$order=$remote_connection->query('SELECT * FROM `'.SITE.'_pages` WHERE `page_id`='.$page_id.' ORDER BY `section_order` DESC')->fetch_assoc();
		$order=$order['section_order']+1;
		if(!$remote_connection->query('INSERT INTO `'.SITE.'_pages` VALUES(NULL,'.$page_id.','.$order.',\''.$props['section_title'].'\',\''.$props['section_main'].'\',\''.$props['plugin-reference'].'\')')) return false;
		return $remote_connection->insert_id;
	}
	static function move_page($id,$where) {
		// $where > 0 : UP
		// $where < 0 : DOWN
		global $remote_connection;
		$q0=$remote_connection->query('SELECT * FROM `'.SITE.'_pageindex` WHERE `id`='.$id);
		$q1=$remote_connection->query('SELECT * FROM `'.SITE.'_pageindex` ORDER BY `page_order` DESC');
		if(!$q0||!$q1) return false;
		$r0=$q0->fetch_assoc();
		$r1=$q1->fetch_assoc();
		$old_pos=$r0['page_order'];
		$max_pos=$r1['page_order'];
		$new_pos=$old_pos-$where;
		if($new_pos<1||$new_pos>$max_pos) return false;
		return $remote_connection->query('UPDATE `'.SITE.'_pageindex` SET `page_order` = IF( `page_order` ='.$old_pos.', '.$new_pos.', '.$old_pos.' ) WHERE `page_order` IN ( '.$old_pos.', '.$new_pos.' )');
	}
	static function move_section($id,$where) {
		// $where > 0 : UP
		// $where < 0 : DOWN
		global $remote_connection;
		$section=self::get_section($id);
		$page_id=$section['page_id'];
		$q0=$remote_connection->query('SELECT * FROM `'.SITE.'_pages` WHERE `id`='.$id);
		$q1=$remote_connection->query('SELECT * FROM `'.SITE.'_pages` WHERE `page_id`='.$page_id.' ORDER BY `section_order` DESC');
		if(!$q0||!$q1) return false;
		$r0=$q0->fetch_assoc();
		$r1=$q1->fetch_assoc();
		$old_pos=$r0['section_order'];
		$max_pos=$r1['section_order'];
		$new_pos=$old_pos-$where;
		if($new_pos<1||$new_pos>$max_pos) return false;
		return $remote_connection->query('UPDATE `'.SITE.'_pages` SET `section_order` = IF( `section_order` ='.$old_pos.', '.$new_pos.', '.$old_pos.' ) WHERE `section_order` IN ( '.$old_pos.', '.$new_pos.' )');
	}
	static function edit_page($id,$new_props) {
		global $remote_connection;
		$sets='';
		foreach($new_props as $col=>$prop) {
			$sets.='`'.$col.'`=\''.$prop.'\', ';
		}
		$sets=substr($sets,0,-2);
		return $remote_connection->query('UPDATE `'.SITE.'_pageindex` SET '.$sets.' WHERE `id`='.$id);
	}
	static function edit_section($id,$new_props) {
		global $remote_connection;
		$sets='';
		foreach($new_props as $col=>$prop) {
			$sets.='`'.$col.'`=\''.$prop.'\', ';
		}
		$sets=substr($sets,0,-2);
		return $remote_connection->query('UPDATE `'.SITE.'_pages` SET '.$sets.' WHERE `id`='.$id);
	}
	static function get_page_where($requested_props) {
		global $remote_connection;
		$where='';
		foreach($new_props as $col=>$prop) {
			$where.='`'.$col.'`=\''.$prop.'\' AND ';
		}
		$where=substr($where,0,-5);
		$q=$remote_connection->query('SELECT * FROM `'.SITE.'_pageindex` WHERE '.$where.' ORDER BY `page_order` ASC');
		if(!$q) return array();
		$PAGES=array();
		while($page=$q->fetch_assoc()) {
			$PAGES[]=$page;
		}
		return $PAGES;
	}
	static function get_section_where($requested_props) {
		global $remote_connection;
		$where='';
		foreach($requested_props as $col=>$prop) {
			$where.='`'.$col.'`=\''.$prop.'\' AND ';
		}
		$where=substr($where,0,-5);
		$q=$remote_connection->query('SELECT * FROM `'.SITE.'_pages` WHERE '.$where.' ORDER BY `section_order` ASC');
		if(!$q) return array();
		$SECTIONS=array();
		while($section=$q->fetch_assoc()) {
			$SECTIONS[]=$section;
		}
		return $SECTIONS;
	}
}