<?php //@./system_remote/plugins/scripts.php ?>
var addons= {
	addons: {
		install: function(site,ref) {
			simplerequest.get('?control=addons&site='+site+'&function=install&a='+ref,'<?php echo $t->_('Addon installed'); ?>','<?php echo $t->_('Error installing addon'); ?>',refreshCurrentTab);
		},
		uninstall: function(site,ref) {
			simplerequest.get('?control=addons&site='+site+'&function=uninstall&a='+ref,'<?php echo $t->_('Addon uninstalled'); ?>','<?php echo $t->_('Error uninstalling addon'); ?>', refreshCurrentTab);
		},
		addto: function(site,ref,col) {
			simplerequest.get('?control=addons&site='+site+'&function=addto&a='+ref+'&col='+col,'<?php echo $t->_('Addon added to column'); ?>','<?php echo $t->_('Error adding addon to column'); ?> ',refreshCurrentTab);
		}
	},
	user: {
		editlvl: {
			func: function(site,user,cont){
				if(cont.value!=cont.getAttribute('orig_val')) {
					simplerequest.get('?control=addons&site='+site+'&function=editlvl&user='+user+'&lvl='+cont.value,'<?php echo $t->_('Userlevel saved'); ?>','<?php echo $t->_('Error saving userlevel'); ?>',refreshCurrentTab);
				}
				else {
					addons.user.editlvl.collapse(cont);
				}
			},
			collapse: function(cont) {
				cont.parentNode.innerHTML=cont.value;
			},
			expand: function(site,user,cont) {
				selectbox=cont;
				newhtml='<select orig_val=\''+selectbox.innerHTML+'\' onblur=addons.user.editlvl.func(\''+site+'\',\''+user+'\',this)>';
				newhtml+=sjax.get('?control=addons&site='+site+'&function=userlvls');
				newhtml+='<\/select>';
				selectbox.innerHTML=newhtml;
				selectbox.getElementsByTagName('select')[0].focus();
			}
		},
		add: function(site,cont) {
			user=cont.parentNode.parentNode.getElementsByTagName('input')[0].value;
			simplerequest.post('?control=addons&site='+site+'&function=adduser','username='+user,'<?php echo $t->_('User added'); ?>','<?php echo $t->_('Error adding user'); ?>',refreshCurrentTab);
		},
		delete: function(site,user) {
			simplerequest.post('?control=addons&site='+site+'&function=deleteuser','username='+user,'<?php echo $t->_('User removed'); ?>','<?php echo $t->_('Error removing user'); ?>',refreshCurrentTab);
		},
		edittitle: {
			func: function(site,user,cont){
				if(cont.value!=cont.getAttribute('orig_val')) {
					simplerequest.get('?control=addons&site='+site+'&function=edittitle&user='+user+'&title='+cont.value,'<?php echo $t->_('Title saved'); ?>','<?php echo $t->_('Error saving title'); ?>',refreshCurrentTab);
				}
				else {
					addons.user.editlvl.collapse(cont);
				}
			},
			collapse: function(cont) {
				cont.parentNode.innerHTML=cont.value;
			},
			expand: function(site,user,cont) {
				selectbox=cont;
				newhtml='<input type="text" orig_val=\''+selectbox.innerHTML+'\' value=\''+selectbox.innerHTML+'\' onblur=addons.user.edittitle.func(\''+site+'\',\''+user+'\',this)>';
				selectbox.innerHTML=newhtml;
				//inputbox.innerHTML='<input type=\'text\' value=\''+inputbox.innerHTML+'\' orig_val=\''+inputbox.innerHTML+'\'onblur=admin.edit_level.func(\''+user+'\',this)>';
				selectbox.getElementsByTagName('input')[0].focus();
			}
		}
	},
	site: {
		delete: function(site) {
			simplerequest.get('?control=addons&site='+site+'&function=deletesite','<?php echo $t->_('Site deleted'); ?>','<?php echo $t->_('Error deleting site'); ?>',window.location.reload);
		},
		settings: function(site,cont) {
			_POST='';
			_POST+='title='+cont.title.value;
			_POST+='&slogan='+cont.slogan.value;
			_POST+='&footer='+cont.footer.value;
			_POST+='&style='+cont.style.value;
			_POST+='&lang='+cont.lang.value;
			_POST+='&author='+cont.author.value;
			_POST+='&admingroup='+cont.admingroup.value;
			_POST+='&submit=1';
			simplerequest.post('?control=addons&site='+site+'&function=settings',_POST,'<?php echo $t->_('Site settings edited'); ?>','<?php echo $t->_('Error editing site settings'); ?>',closeCurrentTab);
		}
	},
	group: {
		edit: function(site,aref,cont) {
			cont.onclick='';
			$(cont).html('<input type="textbox" value="'+$(cont).children('span').html()+'"> <img src="<?php echo URL_IMG; ?>/Silk/group_go.png" onclick="addons.group.update(\''+site+'\',\''+aref+'\',this)" title="<?php echo $t->_('Submit changes'); ?>" alt="[<?php echo $t->_('Submit'); ?>]">');
			textbox=cont.childNodes[0];
			opengroups(textbox);
			textbox.focus();
		},
		update: function(site,aref,cont){
			cont=$(cont).prev()[0];
			simplerequest.post('?control=addons&site='+site+'&function=updategroup&a='+aref,'group='+cont.value,'<?php echo $t->_('Authorized group updated'); ?>','<?php echo $t->_('Error updating authorized group'); ?>',refreshCurrentTab);
		}
	}
}